/*
 * Copyright 2009-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var serializer;
var noTextElements = new Array(new Array('table', true), new Array('thead',
		true), new Array('tfoot', true), new Array('tbody', true), new Array(
		'tr', true), new Array('br', true));

document.onclick = document.click = function(e) {
	// e.preventDefault();

	//if (e.button == 0) {
		// if (haveloc || (s.rangeCount == 0)){;
		var id = activateSelectedLocation(e.target);
		if (id)
			onSelectedLocationChangeByClick();
	//}
};
function getSerializer() {
	if (serializer == null)
		serializer = new XMLSerializer();
	return serializer;
}

// ----------------------------------------------------------------

function undoAction(actions) {
	if(!Array.isArray(actions))
		actions = [actions];
	actions.forEach(function(action,ind){
		switch (action.action) {
		case "create":
			if (!removeLocation(action.uuid));
				//return false;
			break;
		case "delete":
			restoreSelection(action.selection);
			if (!createLocation(action.uuid));
			//	return false;
			break;
		default:
			alert("Unknown action '"
					+ action.actionId
					+ "'. Please, fill bug report at http://forge.ispras.ru/projects/reqdb/");
			//return false;
		}
	});
	return true;
}

function convertXPathToPoint(xpath,start) {
	var node = lookupElementByXPath(xpath.node);
	var offset = xpath.offset;
	if (xpath.nodeType == Node.TEXT_NODE) {
		var children = node.childNodes;
		for (var i = 0; i < children.length; i++) {
			var child = children[i];
			if (child.nodeType != Node.TEXT_NODE)
				continue;
			if (offset < child.nodeValue.length || offset == child.nodeValue.length&&!start) {
				node = child;
				break;
			} else {
				offset -= child.nodeValue.length;
			}
		}
	}
	return {
		node : node,
		offset : offset
	};
}

function restoreSelection(selectionDescriptor) {
	var selection = window.getSelection();
	selection.removeAllRanges();
	var range = document.createRange();
	document.normalize();
	var first=null,last=null,firstOffset=0,lastOffset = 0;
	for (var i = 0; i < selectionDescriptor.length; i++) {
		var rangeDescriptor = selectionDescriptor[i];
		var startPoint = convertXPathToPoint(rangeDescriptor.start,true);
		var endPoint = convertXPathToPoint(rangeDescriptor.end,false);
		 //alert("range start = " + rangeDescriptor.start.node + " ### " +
		 //startPoint.node + " ### " + startPoint.offset );
		if(first!=null)
			tempr.setStart(first,firstOffset);
		if(last!=null)
			tempr.setEnd(last, lastOffset);
		tempr2.setStart(startPoint.node,startPoint.offset);
		tempr2.setEnd(endPoint.node,endPoint.offset);
		if(!first || tempr2.compareBoundaryPoints(Range.START_TO_START, tempr) < 0){
			first = startPoint.node;
			firstOffset = startPoint.offset;
		}

		if(!last || tempr2.compareBoundaryPoints(Range.END_TO_END, tempr) > 0){
			last = endPoint.node;
			lastOffset = endPoint.offset;
		}
//		 alert("range end = " + rangeDescriptor.end.node + " ### " +
	//	 endPoint.node + " ### " + endPoint.offset );
	}
	
	if(first){
		range.setStart(first, firstOffset);
		range.setEnd(last, lastOffset);
	}
	selection.addRange(range);
}

function redoAction(actions) {
	if(!Array.isArray(actions))
		actions = [actions];
	actions.forEach(function(action,ind){
		switch (action.action) {
		case "create":
			restoreSelection(action.selection);
	
			if (!createLocation(action.uuid));
//				return false;
			break;
		case "delete":
			if (!removeLocation(action.uuid));
		//		return false;
			break;
		default:
			alert("Unknown action '"
					+ action.action
					+ "'. Please, fill bug report at http://forge.ispras.ru/projects/reqdb/");
			//return false;
		}
	});
	return true;
}

// ----------------------------------------------------------------

function serializeDocument() {
	removeAllLinks();
	deactivateLocations();
	var scripts = removeScripts();
	var res = serializeDocumentRaw();
	injectScripts(scripts);
	addLocationLinks();
	return res;
}

function serializeDocumentRaw() {
	return getSerializer().serializeToString(document);
}

function injectScripts(scripts) {
	var head = document.getElementsByTagName('head')[0];
	for(var i in scripts[0])
		{
			var node = scripts[0][i];
			head.appendChild(node);
		}
	document.getElementsByTagName('body')[0].appendChild(scripts[1]);
}

function removeScripts() {
	var scrs = [];
	var node = document.getElementById('jquery_js')
	scrs.push(node);
	node.parentNode.removeChild(node);
	node = document.getElementById('blackbird_js');
	scrs.push(node);
	node.parentNode.removeChild(node);
	node = document.getElementById('blackbird_css');
	scrs.push(node);
	node.parentNode.removeChild(node);
	node = document.getElementById('edit_js');
	scrs.push(node);
	node.parentNode.removeChild(node);
	node = document.getElementById('edit_css');
	scrs.push(node);
	node.parentNode.removeChild(node);
	node = document.getElementById('blackbird');
	node.parentNode.removeChild(node);
	return [ scrs, node ];
}

/**
 * Mark intersections of range and text node range.
 * 
 * new:
 * 
 * <span class="requality_text id_${uuid}"> <a name="${uuid}" id="id_${uuid}"
 * class="requality_id"/> <span class="requality_link
 * requality_link_(in)?visible">${id}</span> ... </span> <span
 * class="requality_text id_${uuid}">...</span>
 * 
 * old:
 * 
 * <span class="location_text id_${uuid}"><a name="${uuid}" id="id_${uuid}"
 * class="location_id id_${uuid}"/>...</span> <span class="location_link
 * id_${uuid} location_link_(in)?visible>${id}</span> <span
 * class="location_text id_${uuid}">...</span> <span class="location_text
 * id_${uuid}">...<span class="location_end id_${uuid}"/></span>
 * 
 * @param range
 * @param textNode
 * @return 1 if intersection of range and textNode is not empty and is not equal
 *         to textNode To mark such intersection we add one child node.
 */
// mark for
var textStart = false;
function markTextRange(id, range, textNode) {
	var r = tempr;
	r.selectNode(textNode);
	var res = 0;
	var isStart = false;
	var isEnd = false;
	var selectedAll = true;
	var cut = false;
	// r is before range: r.end <= range.start
	if (range.compareBoundaryPoints(Range.END_TO_START, r) > 0)
		return [0,false];
	// r is after range: range.end <= r.start
	if (range.compareBoundaryPoints(Range.START_TO_END, r) < 0)
		return [0,false];
	switch (range.compareBoundaryPoints(Range.START_TO_START, r)) {
	case 1:
		r.setStart(range.startContainer, range.startOffset);
		cut = true;
		selectedAll = false;
	case 0:
		isStart = true;
	}
	switch (range.compareBoundaryPoints(Range.END_TO_END, r)) {
	case -1:
		r.setEnd(range.endContainer, range.endOffset);
		cut = true;
		selectedAll = false;
	case 0:
		isEnd = true;
	}
	// if inner text is null, do not count it
	//if (r.toString().length == 0)
		//return [0,false];
	var span = document.createElement('span');
	span.setAttribute("class", "requality_text id_" + id);
	var a = null;
	if (isStart || textStart) {
		a = document.createElement("a");
		textStart = false;
		a.setAttribute("name", id);
		a.setAttribute("id", "id_" + id);
		a.setAttribute("class", "requality_id");
	}
	
	//var reqwrap = $("<span/>").attr("class", "requality_text id_" + id);
	if(selectedAll){
		span = textNode.parentNode.insertBefore(span,textNode);
		span.appendChild(textNode);
	}else{
		r.surroundContents(span);
	}
	
	if(a!=null)
		span.insertBefore(a,span.firstChild);

	// if( isEnd )
	// {
	// reqwrap.append($("<span/>").attr("class","location_end id_"+id));
	// }
	return [1, cut];
}

function getNoTextFlag(node, array) {
	for (var i = 0; i < array.length; i++)
		if (array[i][0] == node)
			return array[i][1];
	return false;
}
/**
 * Mark part of 'node'-subtree that is contained in 'range'
 * 
 * @param id -
 *            location unique id
 * @param range
 * @param node
 * @return number of modified ranges
 */
var tempr = document.createRange(), tempr2 = document.createRange();
function getCompareState(node, range, ctype){
	tempr.selectNode(node);
	return range.compareBoundaryPoints(ctype, tempr);
}
function markRange(id, range, node) {
	var skipText = false;
	skipText = getNoTextFlag(node.localName, noTextElements);
	var childNodesCount = node.childNodes.length;
	var tnodes = 0;
	if (childNodesCount > 0) {
		var r = tempr;
		var f1 = 0, f2 = 0,l1=childNodesCount, l2=childNodesCount;
		//org.eclipse.swt.SWTException: Parameter is not an object
		var mi1 = (l1+f1)/2>>0, mi2 = (l2+f2)/2>>0;
		var m1=getCompareState(node.childNodes.item(mi1),range,Range.START_TO_END),
			m2=getCompareState(node.childNodes.item(mi2),range,Range.END_TO_START);
		while(f1<l1 && f2<l2 && l1>0 && f2<childNodesCount)
			{
				mi1 = (l1+f1)/2>>0;
				mi2 = (l2+f2)/2>>0;
				//compare end of range and start of node.item(mi1)
				m1=getCompareState(node.childNodes.item(mi1),range,Range.START_TO_END);
				//compare start of range and end of node.item(mi2)
				m2=getCompareState(node.childNodes.item(mi2),range,Range.END_TO_START);
				if(m1<0)
					l1 = mi1;
				else
					f1 = mi1;
				if(m2>0)
					f2 = mi2+1;
				else
					l2 =mi2;
			}
		for (var i = f2; i < l1; i++) {
			var child = node.childNodes.item(i);
			if (child == null)
				continue;
			if (child.nodeType == Node.TEXT_NODE) {
				if (!skipText) {

					var newChildCount = markTextRange(id, range, child);

					tnodes += newChildCount[0];
					if(newChildCount[1])
						i++;
					l1 += newChildCount[0];
					childNodesCount += newChildCount[0];
				}
			} else {
				tnodes += markRange(id, range, child);
			}
		}
	} else {
		if (!skipText) {
			var r = tempr;
			r.selectNode(node);
			// r is before range: r.start = r.end < range.start
			if (range.compareBoundaryPoints(Range.END_TO_START, r) > 0) {
				return 0;
			}
			// r is after range: range.end < r.start
			if (range.compareBoundaryPoints(Range.START_TO_END, r) < 0) {
				return 0;
			}
			if(!node.className)
				node.className = "";
			if (node.className.indexOf("requality_node")<0)
				node.className += " requality_node";
			if (node.className.indexOf("id_" + id)<0)
				node.className += " id_" + id;
			if (node.tagName == "img") {
			//TODO provide dom appendChild instead of jquery
				var reqwrap = $("<span/>").attr("class",
						"requality_text id_" + id);
				r.surroundContents(reqwrap.get(0));
				$(node).before(
						$("<a/>").attr("name", id).attr("id", "id_" + id).attr(
								"class", "requality_id"));
			}
			tnodes = 1;
		}
	}
	return tnodes;
}

/**
 * Mark selection with tags/styles
 * 
 * @param id -
 *            location unique id
 * @returns selection descriptor: array of range descriptors
 * @see createRangeDescriptor
 */
function markSelection(id) {
	//printToConsole("-----------------------------------------------------------treemark: "+tree(document.documentElement));
	document.normalize();
	var selection = window.getSelection();
	switch (selection.rangeCount) {
	case 0:
		alert("Selection is empty");
		return null;
		// case 1:
		// break;
	default:
		// alert( "Multipart selection processing is experimental. Please,
		// report any bugs found." );
	}
	var selectionDescriptor = [];
	textStart = true;
	var map = [];
	for (var r = 0; r < selection.rangeCount;r++ ){
		var range = selection.getRangeAt(r);
		map[range]=createRangeDescriptor(range);
	}
	for (var r = 0; r < selection.rangeCount; r++) {
		var range = selection.getRangeAt(r);
		var rd = map[range];
		var changednodes = 0;
		// alert( "range.startOffset: " + range.startOffset );
		// alert( "range.endOffset: " + range.endOffset );
		var container = range.commonAncestorContainer;
		if(container == null)
			printToConsole("null cont!");
		else{
			if (container.nodeType == Node.TEXT_NODE) {
				// range is a part of text node. Mark intersection.
				var res = markTextRange(id, range, container);
				if(res != null && res != 0){
					changednodes = res[0];
					if(changednodes[1])
						r++;
				}
			} else {
				// Find text node children and mark intersections.
				// Find nodes without text children and mark them also.
				changednodes = markRange(id, range, container);
			}
		}
		if (changednodes > 0) {
			selectionDescriptor.push(rd);
		}
	}
	selection.collapseToStart();
	//printToConsole("-----------------------------------------------------------treeaftermark: "+tree(document.documentElement));
	return selectionDescriptor;
}

/**
 * This function wrap selection in special requality tags. <br>
 * <br>
 * <i>Can be used in java</i>
 * 
 * @param id
 *            UUID
 * @param userId
 *            user visible id( <i>For example, 'some.id.01'</i> )
 * @return - selection text
 */
function createLocation(id) {
	var selectionDescriptor = markSelection(id);
	if (!selectionDescriptor){
		return null;
	}
	//addLocationLink(id);
	if(selectionDescriptor.length>0){
		var action = {
			action : "create",
			uuid : id,
			selection : selectionDescriptor
		};
		var text = "";
		for (var r = 0; r < selectionDescriptor.length; r++) {
			var rangeDescriptor = selectionDescriptor[r];
				text += rangeDescriptor.text;
		}
		if (selectionDescriptor.length > 0)
			return [ text, JSON.stringify(action) ];
	}
	return null;
}

function getSelectionText() {
	return window.getSelection().toString().replace(/\r/g, "");
}

function addLocationLinks() {
	// var locations = getDocumentLocationIds();
	// if( locations.length == 0 ) return;
	// var id2links = getLocationsToRequirementMap( locations );
	// for( var i = 0; i < id2links.length; i++ )
	// {
	// var chunk = id2links[i];
	// for( var j = 1; j < chunk.length; j++ )
	// {
	// addLocationLink( chunk[0], chunk[j] );
	// }
	// }
}

var linkMap = [];

function removeOnEmpty(node) {
	var r = document.createRange();
	r.selectNode(node);
	if (!isRangeSelectable(node, r))
		node.remove();
}

function removeAllLinks() {
	while(linkMap.length>0){
		var node = linkMap[0];
		if(node!=null && node.parentNode)
			node.parentNode.removeChild(node);
		linkMap.splice(0,1);
	}
}
function getSelectedLocationUUIDFromNode(f, range) {
	var id = null;
	if (!f)
		return null;
	if (!id) {
		try {
			var ssid = f.className;
			if (ssid) {
				if (range) {
					tempr.selectNode(f);
					var k = range.compareBoundaryPoints(Range.END_TO_START,
							tempr); 
					if (k != 0 && k == range.compareBoundaryPoints(
							Range.START_TO_END, tempr))
						return null;
				}
				id = ssid;
			}
		} catch (e) {
			// printToConsole(e+" "+e.message+" "+e.lineNumber+" ;");
		}
	}
	return id;
}

function getSelectedLocation(){
	var els =  document.getElementsByClassName("requality_node_active");
	var node = null;
	for(key in els){
		node = els[key];
		break;
	}
	if(!node){
		var els = document.getElementsByClassName("requality_text_active");
		for(key in els){
			node = els[key];
			break;
		}
	}
	var id = null;
	if(node)
		id = node.className;
	if (!id)
		return null;
	var fst = id.indexOf("id_");
	var spc = id.indexOf(" ", fst);
	if (spc == -1)
		spc = id.length;
	id = id.substring(fst + 3, spc);
	return id;
}


function getSelectedLocationUUID(startNode) {
	var id = null;
	var s = window.getSelection();
	var parentSel = false;
	var nodes = [];
	try {
		if(!id)
			for (var i = 0; i < s.rangeCount; i++) {
				var range = s.getRangeAt(i);
				var key;
				var tempnodes = getNodesInRange(range);
				for (key in tempnodes) {
					var node = tempnodes[key];
					nodes[key] = node;
					id = getSelectedLocationUUIDFromNode(node, range);
					if (id)
						break;
				}
				if (id)
					break;
			}
		if (!id && s.rangeCount == 0) {
			var startt = s.focusNode,
				endt = s.anchorNode;
			var nodes = getNodesForBorderedNodes(startt,endt,true);
			var node, key;
			for (key in nodes) {
				node = nodes[key];
				id = getSelectedLocationUUIDFromNode(node, null);
				if (id)
					break;
			}
		}
		if(!id && startNode && (startNode.classList.contains("requality_text")
				|| startNode.classList.contains("requality_node"))){
			if(startNode.className)
				id = startNode.className;
		}
		if (!id)
			return null;
		var fst = id.indexOf("id_");
		var spc = id.indexOf(" ", fst);
		if (spc == -1)
			spc = id.length;
		id = id.substring(fst + 3, spc);
	} catch (e) {
		printToConsole(e + "");
	}
	return id;
}

function getDocumentLocationIds() {
	var res = [];
	$(".requality_id").each(function() {
		var id = this.getAttribute("id");
		res.push(id.substring(3));
	});
	return res;
}
function getNextNode(node) {
	if (node == null)
		return null;
	if (node.firstChild)
		return node.firstChild;
	if (node.nextSibling)
		return node.nextSibling;
	node = node.parentNode;
	if (node == null)
		return null;
	var sib = node.nextSibling;
	while (!sib && node) {
		node = node.parentNode;
		if(node)
			sib = node.nextSibling;
	}
	if (!sib)
		return null;
	return sib;
}
function getPreviousNode(node) {
	if (node == null)
		return null;
	if (node.previousSibling)
		return node.previousSibling;
	return node.parentNode;
}

function checkReqClasses(node){
	if(node && node.classList &&
			(node.classList.contains("requality_text")
			|| node.classList.contains("requality_node"))){
			return true;
	}
	return false;
}

function getNodesForBorderedNodes(start, end,  locateLocations) {
	if(locateLocations === undefined)
		locateLocations = true;
	if(!start)
		start = end;
	if (!start || !end)
		return [];
	var nodes = [];
	var node, ln = start;
	var lastOne = getNextNode(end);
	var stop = false;
	node = start.parentNode;
	if(checkReqClasses(node))
		nodes.push(node);
	node = end.parentNode;
	if(checkReqClasses(node))
		nodes.push(node);
	node = start;
	do{
		stop = node == lastOne;
		if(node){
			if(!locateLocations){
				nodes.push(node);
			}else{  
				if(checkReqClasses(node))
					nodes.push(node);
			}
		}
		node = getNextNode(node);
	}while(node && !stop);
	return nodes;
}
function parents(node) {
  var nodes = []
  for (; node; node = node.parentNode) {
    nodes.push(node)
  }
  return nodes
}

function getNodesInRange(range, locateLocations) {
	if(locateLocations === undefined)
		locateLocations = true;
	var start = range.startContainer;
	var end = range.endContainer;
	return getNodesForBorderedNodes(start, end, locateLocations);
}
function formTextIt(text, ids){
	var id = "";
	for(var i = 0;i<ids.length;i++){
		if(i>0)
			id+=", ";
		id+=text + ids[i];
	}
	return id;
}
function removeLocation(ids) {
	if(!Array.isArray(ids))
		ids = [ids];
	//printToConsole("-----------------------------------------------------------treedel: "+tree(document.documentElement));
	document.normalize();
	var temp = "[";
	var selectedNodesText = [];
	var selectedNodes = [];
	var map = [];
	oldparents = [];
	var selectionDescriptor = [];
	var parentmap=[];
	//ids.forEach(function(id,index){
		var t = $(formTextIt("span.requality_text.id_",ids)+", "+formTextIt(".requality_node.id_",ids));
		// get parents of nodes to be removed
		$(formTextIt("a.requality_id#id_",ids)).remove();
		t.each(function() {
			if(!!this.className){
				var cl = this.className+" ";
				var idss = cl.indexOf("id_");
				var ide = cl.indexOf(" ",idss); 
				var id = cl.substring(idss+3,ide);
				if(cl.indexOf("requality_text")==-1){
					cl = this.className;
					ids.forEach(function(id,index){
						cl = cl.replace(new RegExp("id_" + id,"g"),"");
					});
					if(cl.indexOf("id_")<0)
						cl = cl.replace(/requality_node/g,"");
					this.className = cl.replace(/requality_node_active/g,"").trim();
					var ind = activeNodeList.indexOf(this);
					if(ind>-1)
						activeNodeList.splice(ind,1);
					if(selectedNodes.indexOf(this)<0){
						//range.selectNode(this);
						selectedNodes.push(this);
						selectedNodesText.push([false,this,id]);
					}
				}else{
					var childs = this.childNodes;
					if(!!childs && childs.length>0){
						//text is prev, may conc
						var next = this.nextSibling;
						for(var i = 0;i<childs.length;i++)
						{
							var child = childs[i];
							var start = 0;
							var len = 0;
							var val = null;
							if(child.nodeType==3){
								len = child.nodeValue.length;
								val = child.nodeValue;
							}
							//предположим что нет текста в тегах без спана
							child = this.parentNode.insertBefore(child,this);
							if(child.nodeType==3){
								
								start = child.nodeValue.length-len;
								var prev = child.previousSibling;
								if(prev!=null&&prev.nodeType==3)
								{
									start += prev.nodeValue.length;
									prev.nodeValue += child.nodeValue;
									this.parentNode.removeChild(child);
									child = prev;
								}
								if(i==(childs.length-1)&&(next!=null)&&next.nodeType==3){
									child.nodeValue +=next.nodeValue;
									this.parentNode.removeChild(next);
									next = null;
								}
								selectedNodesText.push([true,child,start, start+len,id,val]);
							}
						}
					}
					this.parentNode.removeChild(this);
				}
			}
			else
				printToConsole("not text "+this.tagName+" ");
			
		});
		
		var first = -1, last = -1;
		var ftext, ltext;
		var range = document.createRange();
		// move text from inside of span before it
		//t.remove();
		var ids2 = [];
		for(var i = selectedNodesText.length-1;i>-1;i--){
			if(selectedNodesText[i][0]){
				var id = selectedNodesText[i][4];
				range.setStart(selectedNodesText[i][1], selectedNodesText[i][2]);
				range.setEnd(selectedNodesText[i][1], selectedNodesText[i][3]);
				var rangeDescriptor = createRangeDescriptor(range);
				if(rangeDescriptor.text.replace(/\n/,"").length>0){
					printToConsole(rangeDescriptor.start+" "+rangeDescriptor.end+" "+rangeDescriptor.text);
					//selectionDescriptor[id].push(rangeDescriptor);
					//if(typeof ids2[id] === 'undefined')
					var action = {
							action : "delete",
							uuid : id,
							selection : [rangeDescriptor]
					};
						//printToConsole("-----------------------------------------------------------treeafterdel: "+tree(document.documentElement));
					temp+=(temp=="["?"":",")+JSON.stringify(action);
				}
			}else{
				range.selectNode(selectedNodesText[i][1]);
				var rangeDescriptor = createRangeDescriptor(range);
				var action = {
						action : "delete",
						uuid : selectedNodesText[i][2],
						selection : [rangeDescriptor]
				};
					//printToConsole("-----------------------------------------------------------treeafterdel: "+tree(document.documentElement));
				temp+=(temp=="["?"":",")+JSON.stringify(action);
			}
		}
	//});
//	for(var i = 0;i<selectedNodes.length;i++)
//	{
//		printToConsole("del range : "+selectedNodes[i]);
//		range.selectNode(selectedNodes[i]);
//		var rangeDescriptor = createRangeDescriptor(range);
//		//selectionDescriptor.push(rangeDescriptor);
//	}
	//for( var i = 0;i<oldparents.length;i++)
		//oldparents[i].normalize();
		
	return temp+"]";
}

var activeTextList=[], activeNodeList=[];

function deactivateLocations() {
	//Excess but usefulls
	while(activeNodeList.length > 0){
		var node = activeNodeList[0];
		node.className =
			node.className.replace
			( "requality_node_active" , '' ).trim();
		activeNodeList.splice(0,1);
	}
	while(activeTextList.length > 0){
		var text = activeTextList[0];
		text.className =
			text.className.replace
				( "requality_text_active" , '' ).trim();
		activeTextList.splice(0,1);
	}
}

function setSelection(nde) {
	var r = document.createRange();// tempr;
	var s = window.getSelection();
	s.removeAllRanges();
	r.selectNodeContents(nde);
	s.addRange(r);
	s.collapseToEnd();
}

function activateLocation(id, scroll) {
	deactivateLocations();
	var loc = document.getElementById("id_"+id);
	if (loc == null || loc.tagName!="a") {
		return;
	}
	var idnodes = document.getElementsByClassName("id_"+id);
	for(var i=0;i<idnodes.length;i++){
		var node = idnodes[i];
		if(node.className === undefined){
			activeTextList.splice(activeTextList.indexOf(node),1);
			activeNodeList.splice(activeNodeList.indexOf(node),1);
			i--;
		}
		var cl = node.className;
		if(cl.indexOf("requality_node")>-1){
			activeNodeList.push(node);
			node.className+=" requality_node_active";
		}
		if(cl.indexOf("requality_text")>-1){
			activeTextList.push(node);
			node.className+=" requality_text_active";
		}
	}

	if (scroll) {
		window.scrollTo(0, $(loc).offset().top - window.innerHeight / 2);
	}
	setSelection(loc.parentNode);
}

function activateSelectedLocation(node) {
	var id = getSelectedLocationUUID(node);
	if (id != null) {
		activateLocation(id, true);
		return id;
	} else {
		deactivateLocations();
	}
	return null;
}

/**
 * Search for aString with given options. <br>
 * <br>
 * <i>Can be used in java</i>
 */
function findText(aString, aCaseSensitive, aBackwards, aWrapAround) {
	return window.find(aString, aCaseSensitive, aBackwards, aWrapAround, false,
			false, false);
}

/**
 * Selecting requality Location node and makes it orange. <br>
 * <br>
 * <i>Can be used in java</i>
 */
function selectNode() {
	alert('selectNode');
}

function getBrowserInfo() {

	var appName = navigator.appName;
	var appAgent = navigator.userAgent;
	var appVersion = navigator.appVersion;
	return "Browser: " + appName + "; UserAgent: " + appAgent + "; Version: "
			+ appVersion;
}
function isSelectable() {
	var id = getSelectedLocationUUID();
	if (id)
		return false;
	return getSelectionText().length > 0;
}

/**
 * <i>Can be used in java</i>
 * 
 * @return - <b>true</b> if selected node can be unwrapped
 */
function isRemovable() {
	var uuid = getSelectedLocationUUID();
	return uuid != null && uuid.length > 0;
}

function createXPathFromElement(elm) {
	var allNodes = document.getElementsByTagName('*');
	var nodeType = Node.ELEMENT_NODE;
	if (elm.nodeType == Node.TEXT_NODE) // text node
	{
		elm = elm.parentNode;
		nodeType = Node.TEXT_NODE;
	}
	for (segs = []; elm && elm.nodeType == Node.ELEMENT_NODE; elm = elm.parentNode) {
		if (elm.hasAttribute('id')) {
			var uniqueIdCount = 0;
			for (var n = 0; n < allNodes.length; n++) {
				if (allNodes[n].hasAttribute('id') && allNodes[n].id == elm.id)
					uniqueIdCount++;
				if (uniqueIdCount > 1)
					break;
			}
			;
			if (uniqueIdCount == 1) {
				segs.unshift('id("' + elm.getAttribute('id') + '")');
				return {
					node : segs.join('/'),
					nodeType : nodeType
				};
			} else {
				segs.unshift("x:" + elm.localName.toLowerCase() + '[@id="'
						+ elm.getAttribute('id') + '"]');
			}
			// } else if (elm.hasAttribute('class')) {
			// segs.unshift("x:" + elm.localName.toLowerCase() + '[@class="' +
			// elm.getAttribute('class') + '"]');
		} else {
			for (i = 1, sib = elm.previousSibling; sib; sib = sib.previousSibling) {
				if (sib.localName == elm.localName)
					i++;
			}
			;
			segs.unshift("x:" + elm.localName.toLowerCase() + '[' + i + ']');
		}
		;
	}
	;
	return segs.length ? {
		node : '/' + segs.join('/'),
		nodeType : nodeType
	} : null;
};

function resolver(prefix) {
	return "http://www.w3.org/1999/xhtml";
}

function lookupElementByXPath(path) {
	try{
		var evaluator = new XPathEvaluator();
		var result = evaluator.evaluate(path, document, resolver,
				XPathResult.ANY_TYPE, null);
		switch (result.resultType) {
		case XPathResult.UNORDERED_NODE_ITERATOR_TYPE:
			while (true) {
				var node = result.iterateNext();
				if (!node)
					break;
				return node;
			}
		}
	}
	catch(e)
	{
		alert('Ошибка ' + e.name + ":" + e.message + "\n" + e.stack);
	}
	
	return null;
}

function setOffset(elm, offset, point) {
	if(point == null)
	{
		printToConsole("null point!! "+elm+" "+offset);
		return;
	}
	point.offset = offset;
	// alert("setOffset, offset = " + offset + " point.nodeType = " +
	// point.nodeType );
	if (point.nodeType != 3)
		return;
	// alert("setOffset, text node" );
	var parent = elm.parentNode;
	for (var sib = elm.previousSibling; sib; sib = sib.previousSibling) {
		// alert("setOffset, previous sibling" );
		if (sib.nodeType != 3)
			continue;
		// alert("setOffset, previous sibling is text node" );
		point.offset += sib.textContent.length;
		// alert("setOffset, offset = " + point.offset );
	}
}

function createRangeDescriptor(range) {
	var start = createXPathFromElement(range.startContainer);
	setOffset(range.startContainer, range.startOffset, start);
	var end = createXPathFromElement(range.endContainer);
	setOffset(range.endContainer, range.endOffset, end);
	var text = getSerializer().serializeToString(range.cloneContents());
	return {
		start : start,
		end : end,
		text : text
	};
}

function propNames(obj) {
	if (!obj)
		return "obj is undefined";
	var s = "/*" + obj.toString() + ":*/{";
	var comma = false;
	for (p in obj) {
		if (comma)
			s += ",";
		comma = true;
		try {
			s += "|" + p + "=" + obj[p];
		} catch (e) {
			s += "|" + p + "=<not shown>";
		}
	}
	s += "\n}";
	return s;
}

function inspect(obj) {
	alert(propNames(obj));
}

function inspectRange(tip, range) {
	var text = getSerializer().serializeToString(range.cloneContents());
	alert(tip + text);
}

function inspectNode(tip, node) {
	var range = document.createRange();
	range.selectNode(node);
	inspectRange(tip, range);
}

function inspectRangeNode(tip, range, node) {
	var rangeText = getSerializer().serializeToString(range.cloneContents());

	var nodeRange = document.createRange();
	nodeRange.selectNode(node);
	var nodeText = getSerializer().serializeToString(nodeRange.cloneContents());

	alert(tip + " <" + rangeText + "> <" + nodeText + ">");
}

function inspectAction(action) {
	inspect(action.selection[0]);
	inspect(action.selection[0].start);
	inspect(action.selection[0].end);
	var str = "action:" + action.action + "\n" + "uuid:" + action.uuid + "\n"
			+ "selection:" + selectionDescriptorToString(action.selection);
	alert(str);
}

function selectionDescriptorToString(selection) {
	var res = "";
	for (var i = 0; i < selection.length; i++) {
		res += rangeDescriptorToString(selection[i]) + "\n";
	}
	return res;
}

function rangeDescriptorToString(range) {
	var res = "start: " + pointToString(range.start) + "\n" + "end: "
			+ pointToString(range.end) + "\n" + "text:" + range.text;
	return res;
}

function pointToString(point) {
	var res = "{ node:" + point.node + ", nodeType:" + point.nodeType
			+ ", offset:" + point.offset + " }";
	return res;
}
function tree(node) {
	var s = "";
	switch (node.nodeType) {
	case Node.ELEMENT_NODE:
		s += "<" + node.nodeName;
		s += " class=" + node.getAttribute("class") + ">";
		for (var i = 0; i < node.childNodes.length; i++) {
			s += "\n" + tree(node.childNodes.item(i));
		}
		s += "\n</" + node.nodeName + ">";
		break;
	case Node.TEXT_NODE:
		s += "[text]"+node.nodeValue+"[/text]";
	break;
	default:
		s += "{node "+node.nodeName+"}";
	}
	return s;
}
function injectClick( ){
   $(".requality_node").click(function(e) {
	   e.preventDefault();
	   e.stopPropogation();
	   var id = this.parentNode.getElementsByTagName("a")[0].name;
	   activateLocation(id, true);
	   onSelectedLocationChangeByClick();
	});
}

addLocationLinks();
reportDocumentLoaded();
$("a").click(function(e){
	var href = $(this).attr("href");
	if(tryOpenInEditor(href)){
		e.preventDefault();
		e.stopPropogation();
	};
});