var hotkeymode = {
		"handlerCKEditor":function(){return countEditorInstances()>0?true:false;}
};

//disable standard inline editor model
CKEDITOR.disableAutoInline = true;
var attributeUpdate = [];
var cache = [];
var allowedTypes=[];
var extraAttrs=getExtraAttrsNames();
var MENU_OFFSET = 50; 

constructNodeChildren["_default"]= function(nodeData){
		var newNode = document.createElement("div");
		newNode.id="allchildren-"+nodeData.uuid;
		newNode.className="collapsable";
		var nnewNode = $(newNode);
		var childrenNodes = [];
		var j = -1;
		for (var i = 0;i<nodeData.children.length;i++) {
			if(isNodeHeader(nodeData.children[i]))
				j++;
			// Construct the next child subtree (for requirements) or table (for test purposes)
			var chldNode = constructDummyTree(nodeData.children[i]);
			var chldType = chldNode.type;
			if ( synonim[chldType] )
				chldType = synonim[chldType];
			if (!childrenNodes[chldType]) {
				var wrapperConstructor = constructNodeWrapperProcessor[chldType];
				if (wrapperConstructor)
					childrenNodes[chldType] = wrapperConstructor(nodeData.uuid);
				else
					childrenNodes[chldType] = $('<div />');
			}
			childrenNodes[chldType].append(chldNode);
		}
		var hasChildren=hasVisibleChildren(nodeData.uuid);
		// Now append children nodes blocks to the current requirement node
		for (var i = 0; i < childrenNodesOrder.length; ++i) {
			var chldType = childrenNodesOrder[i];
			if (childrenNodes[chldType]) {
				nnewNode.append(childrenNodes[chldType]);
				if(chldType == "General" && hasChildren){
                    nnewNode.addClass('collapsable');
                    nnewNode.prepend($('<img src="images/collapse.png" alt="[&minus;]" class="plusminus" onclick="javascript:toggleChildren(\'' + nodeData.uuid + '\');" />'));
				}
			}
		}
		return nnewNode;
	};
function addToCache(node){
	if(Array.isArray(node)){
		for (var i=0;i<node.length;i++)
			addToCache(node[i]);
	}else{
		if(!(node.uuid in cache)){
			cache[node.uuid]=node;
			if(node.children)
				for(var i = 0;i<node.children.length;i++)
					parentMap[node.children[i]]=node.uuid;
			var par = parentMap[node.uuid];
			if(par){
				var p = getNodeByUUID(par);
				node.path=p.path+getChildNumber(node.uuid)+'.';
				node.deep = p.deep+1;
			}else{
				node.path="1.";
				node.deep = 0;
			}
		}
		//if(node.children)
			//for (var i=0;i<node.children.length;i++) 
				//addToCache(node.children[i]);
	}
}

function loadNodeSubtreeByUUID(uuid){
	if(!(uuid in cache)){
		var node = loadNodeTreeByUUID(uuid);
		if(node)
			addToCache($.parseJSON(node));
	}
	return cache[uuid];
}
var parentMap = [];
function getCachedNodeByUUID(uuid){
	if(!(uuid in cache)){
		return null;
	}
	return cache[uuid];
}
function getNodeByUUID(uuid){
	if(!(uuid in cache)){
		var node = loadNodeByUUID(uuid);
		if(node)
			addToCache($.parseJSON(node));
	}
	return cache[uuid];
}
function getNodeByQID(qid){
	var uid = getNodeUUIDByQID(qid);
	return getNodeByUUID(uid);
}
function getHotKeyMode(){
	for (var key in hotkeymode) {
		  if ({}.hasOwnProperty.apply(hotkeymode, [key])) {
			  if(hotkeymode[key] && hotkeymode[key]())
			  	return key;
		  }
	}
	return 'handlerGlobal';
}
var isSuitable = {
		'addChildRequirementConfirm':function(uuid){
			var type = getType(uuid);
			if(type=="Requirement")
			{
				return canContainType(uuid,"Requirement");
			}			
			return false;
		},
		'addSiblingRequirementConfirm':function(uuid){
			var par = getParentUUID(uuid);
			return uuid!=getStartNode()&&canContainType(par,"Requirement") && getType(par) == "Requirement";
		},
		'addSiblingTextNodeConfirm':function(uuid){
			var par = getParentUUID(uuid);
			var tp = getType(par);
			return uuid!=getStartNode()&&canContainType(par,"TextNode");
		},
		'addChildTextNodeConfirm':function(uuid){
			return canContainType(uuid,"TextNode");
		},
		'editNode':function(uuid){return isEditable($("#block-"+uuid))},
		'switchRequirementType':function(uuid){
			var type = getType(uuid);
			if(type=="Requirement")
			{
				return Number(countChildrenOfType(uuid, "Requirement"))==0&&Number(countChildrenOfType(uuid, "TestPurpose"))==0;
			}			
			return type=="TextNode" && getType(getParentUUID(uuid))!="TextNode" && Number(countChildrenOfType(getParentUUID(uuid), "TestPurpose"))==0;
		},
		'addTestPurpose':function(uuid){
			var type = getType(uuid);
			if(type=="Requirement")
			{
				return Number(countChildrenOfType(uuid, "Requirement"))==0; 
			}			
			return  getType(uuid)=='TestPurpose';
		},
		'addComment':function(uuid){return canContainType(uuid,"Comment") || getType(uuid)=='Comment'; },
		'openTemplates':function(uuid){return true;},
		'deleteNode':function(uuid){return canDeleteNode(uuid);}
};


//Time (in milliseconds) that animations will take
var animationPeriod = 200;

//jQuery array of all elements that can accept keyboard focus
var all_active_elems;

//jQuery array of all elements that can be opened for editing
var all_reditable_elems;

//Index of the element that has keyboard focus
var keyboard_focus;

//Concept: no more than one editor instance is opened at any moment of time.
//Keep this instance in a global variable.
var editor = null;
var editorOpening = false;
var editorJavaDialog = false;
var closeStarted = false;


//Keeps the current read-only mode (ORed values)
var readOnlyMode = 0;

//Created node to change focus on
var nodeToFocus = null;

const EDIT_MODE_REQ_RO = 0x01;  // Requirements are read-only
const EDIT_MODE_VIRTUAL = 0x08;  // Requirements are read-only

//Regular expression to find [linkto: ]
var linktoexp = new RegExp(
		'\\[<span id="([a-zA-Z0-9-]+)">.{0,10}</span>linkto: ([^\\]]*)\\]',
		"mg");
var newlinktoexp = new RegExp(
     '\\[(?:<span id="([a-zA-Z0-9-]+)">.{0,10}</span>)?linkto: ([^\\]]*)\\]',
     "mg");
//function to get displayed version of link in
//regular expressions. 
//Arguments: 
//str - full expression to replace([linkto:...])
//arg1 - if link is new(entered by user),
//contains QualifiedID of target, otherwise, contains
//UUID of target
//arg2 - if linkto contains information about UUID
//(not new one), contains QualifiedID of target
function getLinkForm(str, arg1, arg2) {
	uuid = arg1;
	ufname = arg2;
	//if node was deleted
	newufname = getUFName(uuid);
 var t = document.createElement( 'div' );
 t.innerHTML = newufname;
 newufname = t.innerHTML;
 if((newufname == null)
 //or new Ufname!=old on
 ||(ufname != newufname))
     return "[<span id=\"" + uuid + "\">&zwnj;</span>linkto: " + ufname + "]";
	return '<span class = "linkspan clickable" id = "linkspan-' + uuid + '" onclick = "javascript:openEditorForNode(\'' + uuid + '\');">'
		+ ufname + '</span>';
}
function switchRequirementType(uuid){
	var newType = 'Requirement';
	if(!isSuitable['switchRequirementType'](uuid))
		return;
	if(getType(uuid)=='Requirement')
		newType = 'TextNode';
	else
		if(getType(uuid)!='TextNode')
			return;
	changeNodeAttr(uuid, '_type', newType);
}
function getParentNodeWithClass(element, cls) {
 if (element.className != null && (' ' + element.className + ' ').indexOf(' ' + cls + ' ') > -1)
     return element;
 if(element.parentNode != null)
     return getParentNodeWithClass(element.parentNode,cls);
 return null;
}

function updateLinkDataToDisplay(s){
 s = s.replace(linktoexp, getLinkForm);
 return s.replace(newlinktoexp, markWrongLinks);
}

function getDataOfLinkTo(uuid, linkto){
	if(uuid == null || uuid == "")
		return '[linkto: ' + linkto.replace(/  /g,"&nbsp;&nbsp;") + "]";
	return '[<span id="' + uuid
        + '">&zwnj;</span>linkto: ' + linkto.replace(/  /g,"&nbsp;&nbsp;") + "]";
}

function getNodeStatus(type, val){
	if(type in node_statuses){
		if(val in node_statuses[type]){
			return node_statuses[type][val];
		}
	}
	return node_statuses['Requirement']['in process'];
	
}

function wrongLinkUpdate(euuid, sel, node, ufname){
    tsnode = $('#tsdesc-' + euuid)[0];
    var r = sel.ownerDocument.createRange();
    r.setStartBefore(sel);
    var df = r.createContextualFragment(getDataOfLinkTo(node, ufname));
    sel.parentNode.replaceChild(df, sel);
    fromViewToData(euuid);
    changeNodeAttr(euuid, '_description', tsnode.innerHTML);
    //r = sel.ownerDocument.createRange();
    //r.setStartBefore(sel);
    //var df = r.createContextualFragment(getLinkForm(sel, node, ufname));
    //sel.parentNode.replaceChild(df, sel);
    //alert(sel);
}

function fireRedLinkSelection(sel){
	if(sel == null)
		return;
	euuid = getParentNodeWithClass(sel, "nodewrapper");
    if(euuid == null)
        return null;
    euuid = extractUUID(euuid.id);
    uuid = extractUUID(sel.id);
    tolink = uuid.substring(uuid.lastIndexOf("-") + 1);
    //get node that includes this link
    ed = getParentNodeWithClass(sel, "reditable");
    if(extractUUID(ed.id) != uuid)
    	ed = getParentNodeWithClass(sel, "renamable");
    //get type filter to linkto
    nodes = getNodesByUFName(tolink, euuid.substring(euuid.indexOf("_")));
	uuid = uuid.substring(0, uuid.lastIndexOf("-"));
	newlink = null;
    //get test step
    if(uuid != "")
		newlink = getUFName(uuid);
	if(uuid != "" && newlink != null)
	{
		if(newlink != tolink){
			if(nodes == null){
				nodes = [uuid];
			}else{
			    nodes[nodes.length] = uuid;
			}
		    if(nodes.length >= 1){
		    	//select from list
		    	node = fireNodeSelectionFromList(nodes, "Element was renamed. Select appropriate node from list.");
		    	if(node != null){
		    		wrongLinkUpdate(euuid, sel, node, getUFName(node));
		    	}
		    }else{
		    	//we not select from list or
	            node = addNewTestPurposeToEditor();
	            if(node != null){
	            	wrongLinkUpdate(euuid, sel, node, getUFName(node));
	            }
		    }
		}else{
			//uuid is proper, name is proper - all good
			wrongLinkUpdate(euuid, sel, uuid, tolink);
		}
	}else{
		if(nodes == null){
            nodes = [];
        }
        if(nodes.length >= 1){
            //select from list
            node = fireNodeSelectionFromList(nodes, "Element was deleted. Select appropriate node from list.");
            if(node != null){
            	wrongLinkUpdate(euuid, sel, node, getUFName(node));
            }
        }else{
            //we not select from list
            node = addNewTestPurposeToEditor();
            if(node != null){
            	wrongLinkUpdate(euuid, sel, node, getUFName(node));
            }
        }
	}
	return null;
}

function fromViewToData(uuid){
	var elems = $('#block-' + uuid).find(".linkspan");
    //get all links in edited element
    for ( var i = 0; i < elems.length; i++) {
        //get node by class
        //euuid = getParentNodeWithClass(elems[i],"nodewrapper");
        //if(euuid != null)
        //    euuid = extractUUID(euuid.id);
        //if(euuid != uuid)
        //    continue;
        ruuid = extractUUID(elems[i].id);
        ufname = getUFName(ruuid);
        if(ufname != null){
            var r = elems[i].ownerDocument.createRange();
            r.setStartBefore(elems[i]);
            var df = r.createContextualFragment('[<span id="' + ruuid
                    + '">&zwnj;</span>linkto: '
                    + ufname + ']');
            elems[i].parentNode.replaceChild(df, elems[i]);
        }
    }
    var elems = $('#block-' + uuid).find(".wronglink");
    //get all links in edited element
    for ( var i = 0; i < elems.length; i++) {
        //euuid = getParentNodeWithClass(elems[i],"nodewrapper");
        //if(euuid != null)
        //    euuid = extractUUID(euuid.id);
        //if(euuid != uuid)
        //    continue;
        var r = elems[i].ownerDocument.createRange();
        r.setStartBefore(elems[i]);
        //get index from 'id'
        uid = extractUUID(elems[i].id);
        uid = uid.substring(0, uid.indexOf("-"));
        if(uid != "")
        	uid = '<span id="' + uid + '">&zwnj;</span>';
        var df = r.createContextualFragment('[' + uid + 'linkto: ' + elems[i].innerHTML + "]");
        elems[i].parentNode.replaceChild(df, elems[i]);
    }
}

function markWrongLinks(str, arg1,arg2){
    var link = arg2;
    var uuid = arg1;
    if(uuid == null)
    	uuid = "";
    if(link == "")
    	link = "empty";
	return s = '<span id="select-' + uuid + '-'+link.unescapeHtml()+'" style = "color:red" class="linkspan wronglink clickable" onclick="javascript:fireRedLinkSelection(this)">' + link + '</span>';
}


//HTML unescaping
String.prototype.unescapeHtml = function () {
	if(this == "")
		return "";
	var t = document.createElement( 'div' );
	t.innerHTML = this;
	return t.firstChild.nodeValue;
} 

//Aditional plugins for nodes. Now using to
//provide new button for linking. Contains pairs
//'edited_element' => 'plugin_name'. for ex.
//'reqdesc' => 'requality'.
//Can include several plugins, but in such format
//'field' => 'plugin_1, plugin_2, plugin_3'
//PS. requality includes by default, it doesn't
//need to be included. 
var nodePlugins = {};
//Actions to execute before editor will be open
//now used to perform string replacement for
//linking(change from displayed to stored format)
//Format : 'field' => function (elem.id){}
var beforeEditorOpenAction = {};
//Actions to execute when CKEditor Save command is called for different types of fields
var saveAction = {
	'reqname': function (uuid, new_data) {
		new_data = new_data.unescapeHtml();
		if(new_data == "")
			new_data = null;
		if(new_data != null)
			new_data = new_data.replace(/&nbsp;/g, " ");
		if(checkName(uuid,new_data))
			changeNodeAttr(uuid, '_name', new_data);
		else{
			var name = getName(getNodeByUUID(uuid));
			attributeUpdate['_name'](uuid,"_name",name,name);
		}
	},
	'reqdesc': function (uuid, new_data) {
		printToConsole("save desc "+new_data);
		changeNodeAttr(uuid, '_description', new_data);
	},
	'cmtdesc': function (uuid, new_data) {
		changeNodeAttr(uuid, '_description', new_data);
	},
	'tndesc': function (uuid, new_data) {
		changeNodeAttr(uuid, '_description', new_data);
	},
	'tnheader':function (uuid, new_data) {
		new_data = new_data.unescapeHtml();
		if(new_data == "")
			new_data = null;
		if(new_data != null)
			new_data = new_data.replace(/&nbsp;/g, " ");
		if(checkName(uuid,new_data))
			changeNodeAttr(uuid, '_name', new_data);
		else{
			var name = getName(getNodeByUUID(uuid));
			attributeUpdate['_name'](uuid,"_name",name,name);
		}
	},
	'addtext': function (uuid, new_data) {
		var par=getParentUUID(uuid);
		var node = createNode(par,'TextNode',getNextAvalibleId(par),"Add Sibling Text Node[template]",uuid,[['_description',new_data.replace(/&nbsp;/g, " ")]]);
		if(node && node.length>1)
			setFocusByUUID(node);
		var el = document.getElementById("addtext-"+uuid);
		el.innerHTML="";
		el.className="focusedline createText";
		el.style.cssText=null;
	}
};
/**
* Search for aString with given options.
* <br><br><i>Can be used in java</i>
*/
function findText( aString
               , aCaseSensitive
               , aBackwards
               , aWrapAround
               )
{
  return window.find( aString
                    , aCaseSensitive
                    , aBackwards
                    , aWrapAround
                    , false
                    , false
                    , false
                    );
}
function setSelectionText(val){
	 if(editor != null){
	 	editor.insertText(val.toString());
	 }
	    
}
function getSelectionText() {
	 	if(editor != null && editor.getSelection()!=null){
	 		return editor.getSelection().getSelectedText( );
	 	}
	    var selection = window.getSelection();
	    var text = "";
	    for( i = 0; i < selection.rangeCount; i++ )
	    {
	        text += selection.getRangeAt(i).toString();
	    }
	    return text;
	}

function getAttributeName(elem){
	var cl = elem.className+" ";
	var pos = cl.indexOf("attribute-");
	if(pos>-1){
		cl = cl.substr(pos+10,cl.indexOf(" ",pos+1)-pos-10)
		return cl;
	}
}

//Opens editor window in place of the specific DIV element. The previous editor
//instance (if present) is closed (saving all the changes).
//Input parameters:
//	elem       - DIV element to be replaced with the editor (if null, editor will not open)
//	simplified - whether editor should be a simplified version (for in-place renaming)
//cleanHtml  - whether editor should be a simplified version (for in-place renaming)
//Return value:
//	none
function putEditorWithHtmlClean(elem, simplified, cleanHtml) {
	if (!elem)
		return;
	saveEditor();
	editorOpening = true;
	// Clear the node-level clipboard
	internalClipboard = null;
	var editor, f, id, o_html, pk,odata;
    f = $(elem);
    f.attr("contenteditable", true);
    id = f.attr("id");
    pk = f.data("pk");
  //  printToConsole(getAttributeName(elem));
//    elem.innerHTML="";
	var pos = elem.id.indexOf('-');
	 var field_type = elem.id.substr(0, pos);
	 //execude pre-opening actions
	 // for different fields
	 if (beforeEditorOpenAction[field_type])
	     beforeEditorOpenAction[field_type](elem.id);
	 //get list of plugins for editor of this field
	 //for buttons+
	 var add = '';
	 if (nodePlugins[field_type] != null)
		 add += ',' + nodePlugins[field_type];
	//$(elem).attr('contenteditable', 'true');
	var editor;
	// Open new CKEditor instance
	if (simplified) {
		// Simplified version of the editor: no toolbar, no statusbar,
		// special skin without borders
		editor = CKEDITOR.inline( elem.id, {
			bodyClass: 'miniCKE',
			bodyId: 'editor'+elem.id,
			autoUpdateElement:false,
			disableObjectResizing:true,
			language: 'en',
			autoParagraph: false,
			//skin: 'simple',
			removePlugins: 'toolbar',
			startupShowBorders: true,
			resize_enabled: false,
	        forcePasteAsPlainText: true,
			toolbarCanCollapse: true,
			extraPlugins: 'requality'+add,
			keystrokes:
				   [
				      [13,                  '']
				   ]
		});
	}
	else {
		editor = CKEDITOR.inline( elem.id, {
			bodyClass: 'normalCKE',
			bodyId: 'editor'+elem.id,
			autoUpdateElement:false,
			disableObjectResizing:true,
			language:'en',
			autoParagraph:false,
			startupShowBorders:true,
			toolbar:"Requality",
			toolbarStartupExpanded:true,
			toolbarCanCollapse:false,
			extraPlugins:'SimpleImage,sourcedialog,requality'+add,
			forcePasteAsPlainText:true
		} );
	}
	editor.config.allowedContent = true;
	o_html = "";
	odata = "";
	editor.on("dataReady", function() {
      editor.odata = editor.getData();
      return editor.focus();
    });
    editor.on("focus", function() {
      return o_html = f[0].innerHTML;
    });
    editor.onClose = function(e){
       	if(editorJavaDialog)
			return false;
		var n_html, view;
	     editor.destroy(true);
       f.attr("contenteditable", false);
       f.removeClass("cke_focus");
       f.css("position","");
       return true;
    };
    editor.on("blur", function(e) {

        f.attr("contenteditable", false);
        n_html = f[0].innerHTML;
	    if(editor && editor.status == "ready" && o_html !== n_html){			
			editor.execCommand('requalitySave',editor);
        }else{
        	editor.execCommand('requalityExit',editor);
        }
        editor.onClose(e);
        return true;
    });
    editor.on('dialogShow', function (be) {
		// Stop clicks in the dialog from bubbling up to document
		// (Cannot use global live() handler because the bind()'ed event will be called anyway)
		$(CKEDITOR.dialog.getCurrent().getElement().$).find('.cke_dialog').unbind('click.ckeditor').bind('click.ckeditor', function (e) {
			be.preventDefault();
			be.stopPropagation();
		});
	});
	
	editor.on('key', function (e){

		// Catch hotkeys pressed inside the editor
		var elem = f.closest('.supported-node')[0];
		if (hotkeyManager.execHotkeyAction(e, 'handlerCKEditor', elem, extractUUID(elem.id))) {
			//alert(1);
			e.stopPropagation();
		}
	});
	var uuid = extractUUID(elem.id);
	editor.on('beforeCommandExec', function(e){
		if (e!=null && e.data.name == 'requalitySave') {
			printToConsole("save!");
			if(e.editor.status!="ready")
			{
				printToConsole("not ready");
				return false;
			}
			printToConsole("save2!");
			var elem = $(e.editor.element.$);
			var new_data = e.editor.getData();
			printToConsole("save3!");
			if ($(elem).html() == '')
				$(elem).html('&nbsp;');
			var classList = (elem.attr('class')+" "+elem.attr('id')).split(/\s+/);
			for (var i = 0; i < classList.length; i++) {
				var id = classList[i];
				var pos = id.indexOf('-');
				var field_type = id.substr(0, pos);
				var uuid = id.substr(pos + 1);
				printToConsole("save4!");
				if (saveAction[field_type]){
					printToConsole("save4.5!");
					if(e.editor.checkDirty()){
						printToConsole("save5! "+field_type+" "+saveAction[field_type]);
						saveAction[field_type](uuid, new_data.replace(/&nbsp;/g, " "));//.replace(/\n/g,""));
						return true;
					}
				}
			}
			return false;
		}
		return true;
	});
	editorOpening = false;
	return editor;
}

//Opens editor window in place of the specific DIV element. The previous editor
//instance (if present) is closed (saving all the changes).
//Input parameters:
//elem       - DIV element to be replaced with the editor (if null, editor will not open)
//simplified - whether editor should be a simplified version (for in-place renaming)
//Return value:
//none
function putEditor(elem, simplified) {
  putEditorWithHtmlClean(elem, simplified, false);
}


//Toggles (shows or hides) the block with children requirements.
//Input parameters:
//	uuid - UUID of the parent requirement
//Return value:
//	none
function toggleChildren(uuid, time, scilent) {
	if(time === undefined)
		time = animationPeriod;
	var req_children_div = $('#children-General-' + uuid);
	var img_elem = $('#allchildren-' + uuid).children('img.plusminus');
	if (req_children_div.is(':hidden')) {
		req_children_div.removeClass("hiddenChilds");
		req_children_div.slideDown(time);
		$(img_elem).attr('src', 'images/collapse.png').attr('alt', '[&minus;]');
	}
	else {
		req_children_div.addClass("hiddenChilds");
		var funct = function () {
			//if ($(all_active_elems[keyboard_focus]).is(':hidden'))
			if(scilent!==true)
				setFocusByUUID(uuid);
		};
		if(time == 0)
			req_children_div.hide(0, funct);
		else
			req_children_div.slideUp(time, funct);
		
		$(img_elem).attr('src', 'images/expand.png').attr('alt', '[+]');
	}
}

////////////////////////////////////////////////////////////////////////////////
//External functions implemented and injected by Requality

//EMULATION BEGIN
//If running outside of Eclipse the functions are missing, and emulation will be used instead

//Request for the specific node data
//Input parameters:
//	uuid - (String) uuid of the requested node
//Return value:
//	String value containing JSON definition of the node.
if (typeof(loadNodeByUUID) == 'undefined')
{
 // EMULATION
 if( emulateTestProcedure() )
 {
     // TEST PROCEDURE
	 loadNodeByUUID = function (uuid) {
         var elems = {
             '793445e9-a2ea-42dd-8a9e-9ffcde2227ae': '{ "attributes": {"_type": { "key": "_type", "type": "STRING", "value": "TestProcedure" }}, "children": ["82f9c555-9c0c-43d8-9088-fc42b17f60b8","68047e21-1e55-4450-9eea-9c072fd8d739","19a3fb36-33c2-4479-aab9-cf372b6a2220"], "id": "TestProcedure1", "uuid": "793445e9-a2ea-42dd-8a9e-9ffcde2227ae" }',
         };
         return elems[uuid];
     };
 } else {
     // REQUIREMENTS
	 	loadNodeByUUID = function (uuid) {
			// EMULATION
			var elems = {
				'7547c386-6c11-43ce-843f-42a39642cd1e': '{ "attributes": {"_type": { "key": "_type", "type": "STRING", "value": "Requirement" }}, "children": [ "648c2725-4db2-4ad1-8254-aaf4d1aa67fa", "f6c854e9-9058-4b36-a6dc-461b059969cf", "e23c5275-46c7-4e6f-8669-ee6d36f4003f", "450d5815-da17-404d-af93-0e75976ef961" ], "id": "Requirements", "uuid": "7547c386-6c11-43ce-843f-42a39642cd1e" }',
			};
			return elems[uuid];
		};
 }
}
//List of HTML block wrapper constructors for different types of nodes
var constructNodeWrapperProcessor = {
	'Comment': function (uuid) {
		return $('<div id="children-Comment-'+uuid+'" class="children children-Comment" />');
	},
	'General': function (uuid) {
		return $('<div id="children-General-' + uuid + '" class="children children-General" />');
	},
};


if (typeof(getNodeByQID) == 'undefined')
{
	// EMULATION
	if( emulateTestProcedure() )
	{
     // TEST PROCEDURE
     getNodeByQID = function (qid) {
         var elems = {
         };
         return elems[qid];
     };
	} else {
     // REQUIREMENTS
	    getNodeByQID = function (qid) {
			var elems = {
				'/Documents/glib-Arrays-utf8.xhtml/90d7c8a0-d6c1-4917-818f-ff3adbd22ac9': '{ "attributes": { "_description": { "key": "_description", "type": "STRING", "value": "Description" }, "_hidden": { "key": "_hidden", "type": "BOOL", "value": true }, "_type": { "key": "_type", "type": "STRING", "value": "Location" } }, "children": [], "id": "90d7c8a0-d6c1-4917-818f-ff3adbd22ac9", "uuid": "f8cbc0ce-a2f0-44a8-bd9f-2455d7991508" }',
			};
			return elems[qid];
		};
	}
}

function emulateTestProcedure()
{
	return window.location.href.charAt(window.location.href.length-1) == '?';
}
	
//Request for the root element of the selected subtree
//Input parameters:
//	none
//Return value:
//	String value containing uuid of the subtree root node
if (typeof(getStartNode) == 'undefined')
{
	// EMULATION
	if( emulateTestProcedure() )
	{
		// TEST PROCEDURE
		getStartNode = function () {
			return '793445e9-a2ea-42dd-8a9e-9ffcde2227ae';
		};
	} else {
		// REQUIREMENTS
		getStartNode = function () {
			return '7547c386-6c11-43ce-843f-42a39642cd1e';
		};
	}
}

//Request to change the node ID
//Input parameters:
//	uuid   - (String) uuid of the updated node
//	new_id - (String) new ID to be set
//Return value:
//	Boolean value: true if operation was successful, false otherwise
if (typeof(changeNodeId) == 'undefined')
	changeNodeId = function (uuid, new_id) {
		// EMULATION
		return true;
	};
if (typeof(printToConsole) == 'undefined')
	printToConsole = function (uuid, new_id) {
		// EMULATION
		return true;
	};
//Request to change the value of one of the node attributes
//Input parameters:
//	uuid      - (String) uuid of the updated node
//	attr_name - (String) name of the changed attribute
//	new_val   - (String) new attribute value to be set
//Return value:
//	Boolean value: true if operation was successful, false otherwise
if (typeof(changeNodeAttr) == 'undefined')
	changeNodeAttr = function (uuid, attr_name, new_val) {
		// EMULATION
		return true;
	};

//Request to move the node into different subtree
//Input parameters:
//	uuid            - (String) uuid of the moved node
//	new_parent_uuid - (String) uuid of the new parent node
//Return value:
//	Boolean value: true if operation was successful, false otherwise
if (typeof(changeNodeParent) == 'undefined')
	changeNodeParent = function (uuid, new_parent_uuid) {
		// EMULATION
		return true;
	};

//Request to copy the node into different subtree
//Input parameters:
//	uuid            - (String) uuid of the moved node
//	new_parent_uuid - (String) uuid of the new parent node
//	deep            - (Boolean) Whether copy with children or only the node itself
//Return value:
//	Boolean value: true if operation was successful, false otherwise
if (typeof(copyNode) == 'undefined')
	copyNode = function (uuid, new_parent_uuid, deep) {
		// EMULATION
		return true;
	};

if (typeof(openEditorForNode) == 'undefined')
	openEditorForNode = function (uuid) {
	        // EMULATION
	        return true;
	};
	
//Request to insert a new node
//Input parameters:
//	parent_uuid - (String) uuid of the parent node
//	node_name   - (String) name of the new node
//	node_type   - (String) type of the new node
//Return value:
//	Boolean value: true if operation was successful, false otherwise
if (typeof(addNode) == 'undefined')
	addNode = function (parent_uuid, node_name, node_type) {
		// EMULATION
		return true;
	};

if (typeof(canEditNode) == 'undefined')
	canEditNode = function (uuid) {
     // EMULATION
     return true;
 };

if (typeof(checkName) == 'undefined')
	checkName = function (str) {
     // EMULATION
     return true;
 };

//Request to remove a node with all its decendants
//Input parameters:
//	uuid - (String) uuid of the removed node
//Return value:
//	Boolean value: true if operation was successful, false otherwise
if (typeof(removeNode) == 'undefined')
	removeNode = function (uuid) {
		// EMULATION
		return true;
	};

//Request to set focus in Requality window(s)
//Input parameters:
//	uuid - (String) uuid of the newly focused node
//Return value:
//	Boolean value: true if operation was successful, false otherwise
if (typeof(setRequalityFocus) == 'undefined')
	setRequalityFocus = function (uuid) {
		// EMULATION
		return true;
	};

//Request for the current read-only mode
//Input parameters:
//	none
//Return value:
//	Integer value: bit mask with zero or more possible values:
//		EDIT_MODE_REQ_RO - requirements are disallowed to edit
//	Editing includes changing ID/name, description and adding/removing nodes
//	of the corresponding type. Changing status and adding/removing nodes of
//	other types (e.g. comments) is always allowed.
if (typeof(getReadOnlyMode) == 'undefined')
	getReadOnlyMode = function () {
		// EMULATION
		return 0;
	};

//EMULATION END


function getType(uuid){
	var node = getNodeByUUID(uuid);
	if(node!=null){
		return node.attributes._type.value;
	}
	return null;
}
	
////////////////////////////////////////////////////////////////////////////////
//Callback functions that can be called by Requality

//Callback function called by Requality when node or some of its children change outside of UniEditor
//Input parameters:
//	uuid - (String) uuid of the updated node
//Return value:
//	none
//function isNodeHeader(uuid){
//	var ctype = getType(uuid); 
//	if(ctype=='Requirement' 
//			|| ctype=='TextNode' || ctype=="VirtualNode"|| ctype=="TestStep"){
//		var child = getNodeByUUID(uuid);
//		if (ctype=="TestStep" || (ctype=='Requirement'|| ctype=="VirtualNode") && child.children.length>0 && 
//		(countChildrenOfType(uuid, "Requirement")+countChildrenOfType(uuid, "TextNode"))>0 ||
//				child.attributes._textNodeType && 
//				child.attributes._textNodeType.value &&
//				child.attributes._textNodeType.value != 'text')
//		 			return true;
//	}
//	return false;
//	
//}


function pollFunc(fn, uuid, timeout, interval) {
    var startTime = (new Date()).getTime();
    interval = interval || 1000,
    canPoll = true;

    (function p() {
        canPoll = ((new Date).getTime() - startTime ) <= timeout;
        if (!fn(uuid) && canPoll)  { 
            setTimeout(p, interval);
        }
    })();
}

var replaces = [];
function replaceSingleDum(vele){
	var tree = constructTree(vele.attr("id").substr(6),true);
	if(vele.hasClass("focused"))
		foc = elem.id.substr(6);
	if(vele.parent().hasClass("focused"))
		foc = elem.id.substr(6);
	vele.parent().replaceWith(tree);
}
function replaceDummies(elem1,elem2) {
	var foc = null;
	if(!elem2){
		var elems = elem1.find(".dummy");
		if(elem1.hasClass("dummy")){
			elems=[elem1];
		}
		var ch = false;
		Array.prototype.filter.call(elems, function(elem){
			if(elem!=null && elem!==undefined){
				//var pos = replaces.indexOf(elem.id);
				//if(pos==-1){
					//replaces.push(elem.id);
					var vele = $(elem);
					if(vele.isInViewport()){
						replaceSingleDum(vele);
						ch = true;
					}
					//replaces.slice(replaces.indexOf(elem.id));
				//}
				//onChangeNode(elem.id,true);
			}
		});
	}else
	{
		replaceSingleDum(elem2);
		ch = true;
	}
	if(ch){
		updateElList();
		if(foc!=null)
			setFocusByUUID(foc);
	}
	return false;
//    if (elems.length==0) {
  //      return true; // or false, change the IIFE inside condition accordingly.
    //}
}
function handleDeleted(nodeu){
	if(!nodeu)
		return;
	var domblock = $('#block-'+nodeu);
	if(domblock.length>0){
		var parent = domblock.parents().closest(".block");
		if(parent.length>0){
			var pos = $.inArray(nodeu, parentMap);
			if(pos>-1)
				parentMap.slice(pos,1);
			var uid = extractUUID(parent.attr('id'));
			var node = getNodeByUUID(uid);
			if(node){
				pos = $.inArray(nodeu, node.children);
				if(pos>-1&&node.children){
					node.children.splice(pos, 1);
				}
				if(!node.children||node.children.length<1)
					onChangeNode(uid,false);
			}
			domblock.remove();
		}//else it is root
		
	}
}

function updateChildren(node,force){
	if(!node)
		return;
	//lazy
	var domblock = $('#allchildren-'+node);
	var domwrappers = [];
	for(var name in constructNodeWrapperProcessor){
		var el = document.getElementById('children-'+name+'-'+node);
		if(el!=null){
			domwrappers[name] = $(el);
		}
	}
	//var domnode = $("#reqchildren-"+node);
	var changed = false;
	var order = getChildrenOrder(node);
	var dorder = [];
	
	$.each(  $('#allchildren-'+node).children().children(".block"), function(){
		var id = extractUUID(this.id);
		if(id)
			dorder.push(id);
	});
	var cdesc = getCachedNodeByUUID(node);//old node
	var desc = getNodeByUUID(node);
	if(!desc)
		return;//non exitsting node
	var oldsize = dorder.length;
	if(cdesc != null)//if node was in cache
		for(var name in cdesc.children){
			var ind = $.inArray(name, dorder);
			if(ind == -1){
				oldsize++;
				//moved nodes
			}
		}
	var oldOrder = dorder;
	if(!oldOrder)
		oldOrder = [];
	var update=false;
	var changeN = false;
	if(oldsize==0&&order.length!=0 ||oldsize!=0&&order.length==0){
		desc.children = order;
		//$("allchildren-"+node).remove();
		onChangeNode(node,false);
		//updateChildren(parentMap[node],false);
		changeN = true;

		var domblock = $('#allchildren-'+node);
		for(var name in constructNodeWrapperProcessor){
			var el = document.getElementById("children-"+name+"-"+node);
			if(el!=null)
				domwrappers[name] = $(el);
		}
		//onChangeNode(node,true);
		//return;
	}
	desc.children = order;
	var crdeep=desc.deep,crpath=desc.path;
	
	printToConsole("dom ended "+desc.uuid+" "+oldsize+" "+order.length);
	var k = 0;
	if(oldsize==order.length && !force){
		var changed = false;
		for(var i=0;i<oldsize&&!changed;i++){
			if(!oldOrder[i]){
				changed = true;
				break;
			}
			var chi = getNodeByUUID(order[i]);
			if(isNodeHeader(oldOrder[i]))
				k++;
			if(oldOrder[i]!=order[i]){
				changed = true;
				break;
			}
			else
			{
				var rpath2=crpath+(k)+".";
				if(rpath2!=chi.path){
					changed = true;
					break;
				}
			}
		}
		if(!changed){
			printToConsole("nch");
			return;
		}
	}
	if(oldsize.length==order.length && !changed)
		return;
	keyboard_focus = -1;
	$('.focused').removeClass('focused');
	
	var i = 0;
	var docelem = [];
	for(i = 0;i<oldOrder.length;i++){
		docelem[oldOrder[i]] = $('#block-' + oldOrder[i]);
		docelem[oldOrder[i]].detach();
	}
	//change required
	j = 0;
	var ne = [];
	var changedp = [];
	var changecount=0; 

	for(i = 0;i<order.length;i++){
		var chi = getNodeByUUID(order[i]);
		var dom = null;
		if(isNodeHeader(order[i]))
			j++;
		var name=getType(order[i]);
		if ( synonim[name] )
			name = synonim[name];
		if(!constructNodeWrapperProcessor[name])
			continue;
		var rpath2=crpath+(j)+".",rdeep2=crdeep+1;
		var container = domwrappers[name];
		if(container == null || container === undefined){
			container = constructNodeWrapperProcessor[name](node);
			domwrappers[name] = container;
			domblock.append(container);
		}
		ne[name]=true;
		if(docelem[order[i]] == null || docelem[order[i]].length==0){
			var fnd = $('#block-' + order[i]);
			if(fnd.length>0)
				docelem[order[i]] = fnd;
		}
		if(docelem[order[i]]!=null && docelem[order[i]].length>0){
			//alert("old "+order[i]+" "+container+" "+docelem[order[i]]);
			var dom = docelem[order[i]];
			docelem[order[i]] = null;
			dom.appendTo(container);
			//dom = $(document.getElementById(order[i]));
			var frompath = chi.path;
			if(rdeep2!=chi.deep||rpath2!=chi.path){
				changedp[changecount++]=order[i];
				printToConsole("changed ind "+order[i]+rdeep2+" "+frompath);
			}
			//desc.path=rpath2;
			//desc.deep = rdeep2;
		}else{
			//alert("new "+order[i]);
			//alert(1);
			//updateTree(order[i]);
			dom=constructTree(order[i],true);
			container.append(dom);
			changed = true;
			//domnode.appendChild(constructTree(order[i],0,""));
		}
		var pdom = $("#path-"+order[i]);
		if(pdom)
			pdom.html(rpath2);
		chi.deep=rdeep2;
		chi.path=rpath2;
		
	}
	for(var v in docelem)
	{
		var val = docelem[v];
		if(val){
			val.appendTo(domblock);//late remove
			val.remove();
		}
	}
	//if(update)
		//updateTree(node,rdeep,rpath);
	
	for (var i = 0; i < childrenNodesOrder.length; ++i) {
		var chldType = childrenNodesOrder[i];
		if (domwrappers[chldType]&&ne[chldType]) {
			domblock.append(domwrappers[chldType]);
			if(chldType == "General"){
				if(domblock.children(".plusminus").length == 0){
					domblock.addClass('collapsable');
					domblock.prepend($('<img src="images/collapse.png" alt="[&minus;]" class="plusminus" onclick="javascript:toggleChildren(\'' + node + '\');" />'));
				}
			}
		}
	}
	for(var name in constructNodeWrapperProcessor)
		if(domwrappers[name]!==undefined){
			if(!ne[name]){
				domwrappers[name].remove();
				if(name == "General"){
					var pl = domblock.children(".plusminus");
					pl.remove();
//					domblock.addClass('collapsable');
//					domblock.prepend($('<img src="images/collapse.png" alt="[&minus;]" class="plusminus" onclick="javascript:toggleChildren(\'' + node + '\');" />'));
				}
				//domwrappers[name]=null;
			}//else
				//domwrappers[name].detach();
		}
//	for(var i = 0;i<changecount;i++){
//		updateChildren(changedp[i],true);
//	}
	if(changed)
		updateElList();
	
}
function formLocationDesc(nodeData){
	if (nodeData.attributes._locations) {
		var loc_text = '';
		var loc_new_text = '';
		for (var i in nodeData.attributes._locations.value) {
			try {
				var locJSON = getNodeByQID(nodeData.attributes._locations.value[i].value);
			}
			catch (ex) {
				printToConsole(ex.name+"  "+ex.message+"  "+ex.trace);
				continue;
			}
			if (!locJSON)
				continue;
			if (locJSON.attributes._lhidden && locJSON.attributes._lhidden.value)
				continue;
			var locData = locJSON;
			if (loc_text != '')
				loc_text += '<br />';
			if (!locData.attributes._hidden||!locData.attributes._hidden.value){
					if(locData.attributes._description && locData.attributes._description.value)
						loc_text += locData.attributes._description.value;//.replace(/\n/g,"");
					if(locData.attributes._description && locData.attributes._description.newvalue)
						loc_new_text += locData.attributes._description.newvalue;//.replace(/\n/g,"");
				}
		}
		nodeData.attributes._ldescription = { 'value': (loc_text == '') ? '&nbsp;' : loc_text ,
		'newvalue':(loc_new_text == '') ? '&nbsp;' : loc_new_text};
	}
	else
		nodeData.attributes._ldescription = { 'value': '&nbsp;','newvalue': '&nbsp;'};
}
function handleAttrUpdate(node, vals){
		var name=vals.key;
		var raw=vals.value;
		var val=vals.newvalue;
		var deff = attributeUpdate[name];
		if(!deff)
			deff = attributeUpdate['_default'];
//		else
	//		printToConsole("nondef ach "+name+" "+raw);
		printToConsole(node+" "+name+" < ");	
		deff(node,name,raw,val); 
		printToConsole(node+" "+name+" > ");
}
function handleEvents(arr){
	if(Array.isArray(arr)){
		printToConsole("included! "+arr);
		var arrayLength = arr.length;
		for (var i = 0; i < arrayLength; i++)
			handleEvents(arr[i]); 
	}
	else{
		if(arr.op == "moved"){
			printToConsole("moved "+arr.node+"");
			var node = arr.node;
			var oldp= arr.oldparent;
			var newp=arr.parent;
			parentMap[arr.node]=newp;
			if(newp!=undefined)
				updateChildren(newp);
			if(oldp!=undefined)
				updateChildren(oldp);
			//TODO move
		}else if(arr.op=="deleted"){
			printToConsole("deleted "+arr.node);
		    var node = arr.node;
		    handleDeleted(node);
		    //TODO delete
		}else if(arr.op=="updateChildrenOrder"){
			printToConsole("updateOrder "+arr.node);
			var uuid = arr.node;
			updateChildren(arr.node);
			//var node = getNodeByUUID(uuid);
			
		}else if (arr.op == "changeAttributes"){
			printToConsole("chageAttr "+arr.node);
			var node = arr.node;
			var atatt = arr.values;
			var len = atatt.length;
			printToConsole(node+" changed "+JSON.stringify(atatt));
			for(var j=0;j<len;j++)
				handleAttrUpdate(node, atatt[j]);
		}else if(arr.op == "created"){
			printToConsole("created "+arr.node);
			var node = arr.node;
			var par = arr.parent;
			parentMap[node] = par;
			printToConsole("created "+node+" in "+par);
			updateChildren(par);
		}
	}
}
function onEvents(val){
	//printToConsole("events:'"+val+"'");
	try{
		var arr = JSON.parse(decodeURI(val));
		handleEvents(arr);
	}catch(e){
		alert(e +"\n"+ e.stack);
	}
	//printToConsole("eventsover:'"+val+"'");
}
function formDeepPath (uuid, id,dom){
	var node = getNodeByUUID(uuid);
	return [Number(node.deep)+1,node.path+id+"."];
}
function onChangeNode(uuid, silent) {
	var local = false, last = null;
	printToConsole("node change!");	
	nodeToFocus = getSelectedNode();
	if(!silent && countEditorInstances()>0 && !last){
		local = true;
		for(var name in CKEDITOR.instances){
			var editor = CKEDITOR.instances[name];	
			if(!editor)
				continue;
			last = editor.element.$.id;
			if(editor.status=="ready" && editor.checkDirty()){
				editor.execCommand('requalitySave');
			}else
				editor.execCommand('requalityExit');
		}
	}
	//var pdef = getNodeByUUID(parent[uuid]);
	var rdeep = 0,rpath="",id = -1, j = 0;
	var jspar = getNodeByUUID(getParentUUID(uuid));
	if(jspar)
		for(var i = 0;i<jspar.children.length && id == -1;i++){
			if(isNodeHeader(jspar.children[i]))
				j++;
			if(jspar.children[i]==uuid){
				id = j;
				break;
			}
		}
	if(id == -1)
		id = j+1;
	//todo locate id

	var ret = formDeepPath(getParentUUID(uuid),id);
	var rdeep=ret[0],rpath=ret[1];
	printToConsole("before update "+uuid+" "+rdeep+" "+rpath);

	updateTree(uuid,rdeep,rpath);

	printToConsole("before focus "+nodeToFocus);

	if(nodeToFocus != null){
		setFocusByUUID(nodeToFocus);
		nodeToFocus = null;
	}
	else{
		if(last && local){
			alert(13);

			$("#"+last).click();
			last = null;
		}
	}
}

//Callback function called by Requality when it requests UniEditor to change focus
//Input parameters:
//	uuid - (String) uuid of the node to set focus to
//Return value:
//	none
function onChangeFocus(uuid) {
	// If this is a callback because of setting focus from UniEditor, ignore it

	// Check whether the focus is already on the requested element
	if (all_active_elems==null || all_active_elems[keyboard_focus]&& uuid  == extractUUID(all_active_elems[keyboard_focus].id))
		return;
	// Search for the requested element
	if(!uuid){
		setFocus(null,true);
		return;
	}
	var new_elem = $('#node-' + uuid+", #dummy-"+uuid);

	if (new_elem.length == 0)
		return;
	if (new_elem.is(':hidden')) {
		// Expand all subtrees from the current element up to the root
		new_elem.parents('.hiddenChilds').each(function () {
			var node_uuid = extractUUID(this.id);
			if ($('#children-General-' + node_uuid).is(':hidden'))
				toggleChildren(node_uuid);
		});
		// Wait for all trees to complete expanding, then set focus
		// (otherwise the element will have wrong coordinates and cannot be scrolled to view)
		setFocus(new_elem, true);
		printToConsole("focus5 "+new_elem);
	}
	else {
		setFocus(new_elem, true);
		// The desired element is already visible, set the focus immediately
		//setFocus(new_elem, true);
	}
}


var readOnlyClasses = {};
readOnlyClasses[EDIT_MODE_REQ_RO] = 'requirement';


function isReadOnly(elem){
	for (var flag in readOnlyClasses) {
		if (((readOnlyMode & flag) != 0) && elem.hasClass(readOnlyClasses[flag]))
			return true;
	}
	return false;	
}
// Checks whether the specified element is allowed to edit
// Input parameters:
//	elem - jQuery object with the element to check
// Return value:
//	true if element is editable; false otherwise
function isEditable(elem) {
	if(isReadOnly(elem))
		return false;
	return !getUpdatingState();
}

// Extracts the UUID from DOM element ID
// Input parameters:
//	id - identifier in the form 'smth-XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX'
//	     (UUID with some prefix)
// Return value:
//	UUID extracted from the ID (prefix removed)
function extractUUID(id) {
	//var id = id.substr(id.indexOf('-') + 1);;
	var cnt = 0;
	var ind = id.indexOf("-");
	var poss=[];
	while(ind>-1){
		poss[cnt++]=ind;
		ind = id.indexOf("-",ind+1);
	}
	var j = 0;
	for(var i = 1;i<cnt;i++)
		if(poss[i]-poss[i-1]==5){
			j++;
			if(j == 3)
				return id.substr(poss[i]-23,poss[i]+13);
		}else
			j = 0;
	return null;
}

// Changes the focus to the new element
// Input parameters:
//	elem     - jQuery object with the element to be focused
//	silently - [optional] if true, do not notify Requality about changes
// Return value:
//	none
function setFocus(elema, silently) {
	//var ela = $(elema);
	//if(!ela.hasClass('supported-node')&&!ela.hasClass('dummy'))
		//ela = ela.closest('.supported-node,.dummy');
	try{
		if(!elema){
			if(keyboard_focus>-1){
				$(all_active_elems[keyboard_focus]).removeClass('focused');
				keyboard_focus = -1;
			}
			return;
		}
		
		var ind = all_active_elems.index(elema);
		for(var i = 0;i<=ind;i++){
			var elem = $(all_active_elems[i]);
			if(elem.hasClass("dummy")){
				replaceDummies(elem.parent(),elem);
			}
		}
		elema = all_active_elems[ind];
		var el = $(elema);
		if(!$(elema).hasClass('supported-node'))
			el = $(elema).closest('.supported-node');
		if(keyboard_focus>-1)
			$(all_active_elems[keyboard_focus]).removeClass('focused');
		keyboard_focus = all_active_elems.index(el);
		if(el.hasClass('focused'))
			return;
		if (!silently && elema!=null) {
			var uuid = extractUUID(elema.id?elema.id:elema[0].id);
			setRequalityFocus(uuid);
		}
	//	for(var name in CKEDITOR.instances){
	//		var editor = CKEDITOR.instances[name];
	//		if(editor  && editor.status=="ready"){
	//			if(!closeStarted){
	//				printToConsole("save "+name);
	//				saveEditor();
	//			}
	//		}	
	//	}
		hideMenu();
		el.addClass('focused');
		setTimeout(function () {
			el.scrollToView();
		}, animationPeriod);
	}
	catch(e){
		alert(e+" "+e.stack);
	}
}

// Changes the focus to the new element specified by the index
// Input parameters:
//	idx      - index of the element to be focused
//	silently - [optional] if true, do not notify Requality about changes
// Return value:
//	none
function setFocusByIndex(idx, silently) {
	var new_elem = $(all_active_elems[idx]);
	if(keyboard_focus>-1)
		$(all_active_elems[keyboard_focus]).removeClass('focused');
	keyboard_focus = idx;
	$(all_active_elems[keyboard_focus]).addClass('focused').scrollToView();
	if (!silently) {
		var uuid = extractUUID(all_active_elems[keyboard_focus].id);
		setRequalityFocus(uuid);
	}
	hideMenu();
}

// Changes the focus to the new element specified by the UUID
// Input parameters:
//	uuid     - UUID of the element to be focused
//	silently - [optional] if true, do not notify Requality about changes
// Return value:
//	none
function setFocusByUUID(uuid, silently) {
	var new_elem = $('#node-' + uuid+', #dummy-'+ uuid);
	if(keyboard_focus>-1)
		$(all_active_elems[keyboard_focus]).removeClass('focused');
	if(new_elem!=null)
		setFocus(new_elem);
//	keyboard_focus = all_active_elems.index(new_elem);
//	$(all_active_elems[keyboard_focus]).addClass('focused').scrollToView();
//	if (!silently) {
//		setRequalityFocus(uuid);
//	}
//	hideMenu();
	//TODO test
	//if(editor){
	//	saveEditor();
	//}
}


//List of available commands for all node types
var node_commands = {
	"global":{
		'openTemplates':{
			image: 'templates.png',
			imageAlt: '[Tm]',
			menu: true,
			name: 'Open Templates Editor',
			handler: openTemplates,
			readOnlyMode:0
		}
	},
	'Requirement': {
		'delreq': {
			menu: true,
			name: 'Delete Requirement',
			image: 'delete-node.png',
			imageAlt: '[&minus;]',
			readOnlyMode: EDIT_MODE_REQ_RO,
			handler: deleteNodeConfirm
		},
		'editNode':{
			menu: true,
			name: 'Open Editor',
			image: 'req-status-complete.png',
			imageAlt: '[E]',
			readOnlyMode: EDIT_MODE_REQ_RO,
			handler: editNode
		},
//		'editattr': {
//			menu: true,
//			name: 'Edit attributes',
//			image: 'edit-attrs.png',
//			imageAlt: '[&equiv;]',
//			readOnlyMode: 0,
//			handler: function (uuid) {}
//		},

		'addTest': {
			menu: true,
			name: 'Add Test',
			image: 'dnd-copy.png',
			imageAlt: '[T]',
			readOnlyMode: EDIT_MODE_VIRTUAL,
			handler: callAddTest
		},
		'addreqsib': {
			menu: true,
			name: 'Add sibling Requirement',
			createdType: 'Requirement',
			image: 'add-req.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: addSiblingRequirementConfirm
		},
		'addreqchld': {
			menu: true,
			name: 'Add child Requirement',
			createdType: 'Requirement',
			image: 'add-req.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: addChildRequirementConfirm
		},
		'addtnsib': {
			menu: true,
			name: 'Add sibling Text Node',
			createdType: 'TextNode',
			image: 'add-req.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: addSiblingTextNodeConfirm
		},
		'addtnchld': {
			menu: true,
			name: 'Add child Text Node',
			createdType: 'TextNode',
			image: 'add-req.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: addChildTextNodeConfirm
		},
		'addcmt': {
			menu: true,
			name: 'Add new Comment',
			createdType: 'Comment',
			image: 'add-cmt.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_VIRTUAL,
			handler: addComment
		},
		'chstatus': {
			menu: true,
			image: 'status.png',
			name: 'Change status',
			imageAlt: '[S]',
			readOnlyMode: 0,
			handler: changeStatus
		},
		'chtype': {
			menu: true,
			image: 'switch.png',
			imageAlt: '[Tp]',
			name: 'Switch type to Text Node',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: switchRequirementType
		}
	},
	'TextNode': {
		'delreq': {
			menu: true,
			name: 'Delete Text Node',
			image: 'delete-node.png',
			imageAlt: '[&minus;]',
			readOnlyMode: EDIT_MODE_REQ_RO,
			handler: deleteNodeConfirm
		},
		'editNode':{
			menu: true,
			name: 'Open Editor',
			image: 'req-status-complete.png',
			imageAlt: '[E]',
			readOnlyMode: EDIT_MODE_REQ_RO,
			handler: editNode
		},
//		'editattr': {
//			menu: true,
//			name: 'Edit attributes',
//			image: 'edit-attrs.png',
//			imageAlt: '[&equiv;]',
//			readOnlyMode: 0,
//			handler: function (uuid) {}
//		},

		'addreqsib': {
			menu: true,
			name: 'Add sibling Requirement',
			createdType: 'Requirement',
			image: 'add-req.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: addSiblingRequirementConfirm
		},
		'addtnsib': {
			menu: true,
			name: 'Add sibling Text Node',
			createdType: 'TextNode',
			image: 'add-req.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: addSiblingTextNodeConfirm
		},
		'addtnchld': {
			menu: true,
			name: 'Add child Text Node',
			createdType: 'TextNode',
			image: 'add-req.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: addChildTextNodeConfirm
		},
		'addcmt': {
			menu: true,
			name: 'Add new Comment',
			createdType: 'Comment',
			image: 'add-cmt.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_VIRTUAL,
			handler: addComment
		},
		'chstatus': {
			image: 'tnstatus.png',
			imageAlt: '[TT]',
         menu: true,
         name: 'Change TextNode type',
         readOnlyMode: 0,
         handler: changeStatus
     },
		'chtype': {
			image: 'switch2.png',
			imageAlt: '[Tp]',
			menu: true,
			name: 'Switch type to Requirement',
			readOnlyMode: EDIT_MODE_REQ_RO|EDIT_MODE_VIRTUAL,
			handler: switchRequirementType
		}
	},

	'Comment': {
		'delcmt': {
			menu: true,
			name: 'Delete Comment',
			image: 'delete-node.png',
			imageAlt: '[&minus;]',
			readOnlyMode: 0,
			handler: deleteNodeConfirm
		},
		'editNode':{
			menu: true,
			name: 'Open Editor',
			image: 'req-status-complete.png',
			imageAlt: '[E]',
			readOnlyMode: EDIT_MODE_REQ_RO,
			handler: editNode
		},
		'addcmt': {
			menu: true,
			name: 'Add new Comment',
			createdType: 'Comment',
			image: 'add-cmt.png',
			imageAlt: '[+]',
			readOnlyMode: EDIT_MODE_VIRTUAL,
			handler: addComment
		}
	}
};

//Executes the menu command for the specific node
//Input parameters:
//	node_type - type of the target node
//	uuid      - UUID of the node
//	cmdId     - command to execute
//Return value:
//	none
function execNodeCommand(node_type, uuid, cmdId) {
	if(node_type==null)
		node_type=getType(uuid);
	var rmode = readOnlyMode || getReadOnlyModeOnNode(uuid);
	var cmd = node_commands[node_type][cmdId];
	if (cmd && ((cmd.readOnlyMode & rmode) == 0)) {
		cmd.handler.call($('#node-' + uuid)[0], uuid);
	}else
		{
			var cmd = node_commands["global"][cmdId];
			if (cmd && ((cmd.readOnlyMode & rmode) == 0)) 
				cmd.handler.call($('#node-' + uuid)[0], uuid);
		}
}
//Constructs the HTML block for drop-down menu of the specific node
//Input parameters:
//	node_type - type of the target node
//	uuid      - UUID of the node
//Return value:
//	String value containing the HTML code for the drop-down menu block
function constructMenu(node_type, uuid) {
	var rmode = readOnlyMode || getReadOnlyModeOnNode(uuid);
	var menu = '';
	var menu_commands = node_commands[node_type];
	if (!menu_commands)
		return '';
	for (var cmdId in menu_commands) {
		if (menu_commands[cmdId].menu) {
			var cmdName = menu_commands[cmdId].handler.name;
			if((isSuitable[cmdName]) && !isSuitable[cmdName](uuid))
				continue;
			var hotkey = '';
			if (hotkeyManager.command_hotkeys['handlerGlobal'][cmdName])
				hotkey = '<span style="color: #606060;">[' + hotkeyManager.command_hotkeys['handlerGlobal'][cmdName].join(', ') + ']</span>';
			var className = 'menu-item';
			if ((menu_commands[cmdId].readOnlyMode & rmode) != 0)
				className = 'menu-item-disabled';
			var name = menu_commands[cmdId].name;
			if(menu_commands[cmdId].createdType)
			{
				name+="[template-"+menu_commands[cmdId].createdType+"]";
			}
			menu += '<div class="' + className + ' menu-item-' + cmdId + '" onclick="javascript:execNodeCommand(\'' + node_type + '\', \'' + uuid + '\', \'' + cmdId + '\');"><table><tr><td width="20"><img src="images/' + menu_commands[cmdId].image + '" alt="' + menu_commands[cmdId].imageAlt + '" /></td><td><div class="menu-name ' + className +'-'+ cmdId + '-name">' + name + '</div></td><td align="right"><img src="images/empty.png" alt="" width="10" height="1" />' + hotkey + '</td></tr></table></div>';
		}
	}
	return menu;
}

//Order in which the children node of different types are appended
var childrenNodesOrder = [ 'Comment', 'General' ];
var synonim = {'Undefined':'General',
				'Requirement':'General',
				'TextNode':'General',
				'VirtualNode':'General'};

function getDescription(uuid){
	var nodeData = getNodeByUUID(uuid);
	var desc = null,desc2 = null;;
	if((nodeData.attributes._description && nodeData.attributes._description.newvalue && 
			nodeData.attributes._description.newvalue != ""
		&& nodeData.attributes._description.newvalue != "&nbsp;")){
			desc=nodeData.attributes._description.newvalue.replace(/&nbsp;/g, " ");//.replace(/\n/g,"<br/>");
			desc2=nodeData.attributes._description.value.replace(/&nbsp;/g, " ");//.replace(/\n/g,"<br/>");
		}
			//desc = nodeData.attributes._description.newvalue.replace(/&nbsp;/g, " ").replace(/\n/g,"<br/>");
	if(!desc&&(nodeData.attributes._ldescription && nodeData.attributes._ldescription.newvalue )){
		desc=nodeData.attributes._ldescription.newvalue.replace(/&nbsp;/g, " ");//.replace(/\n/g,"");
		desc2=nodeData.attributes._ldescription.value.replace(/&nbsp;/g, " ");//.replace(/\n/g,"");
	}
	if(!desc){
		desc= "&nbsp;";
		desc2= "&nbsp;";
		}
	desc = desc.replace(/\\\"/g,"\"");
	desc2 = desc2.replace(/\\\"/g,"\"");
	return {'newvalue':desc,'value':desc2};
}
function getName(node){
	if(node.attributes._name&&node.attributes._name.value){
		var name = node.attributes._name;
		if(!name.value)
			name.value="";
		if(!name.newvalue)
			name.newvalue=name.value;
		return {'newvalue':name.newvalue.replace(/  /g,"&nbsp;&nbsp;"),'value':name.value.replace(/  /g,"&nbsp;&nbsp;")};
	}
	return null;
}
function getNameOrId(node){
	var name = getName(node);
	if(name!=null)
		return name;
	return {'newvalue':node.attributes._id.newvalue.replace(/  /g,"&nbsp;&nbsp;"),'value':node.attributes._id.value.replace(/  /g,"&nbsp;&nbsp;")};
}

//Reads the tree contents starting from UUID specified and updates the document
//Input parameters:
//	uuid - UUID of the root element of the updated subtree
//Return value:
//	none
var repl = null;
function constructDummyTree(uuid){
	var ed = document.createElement('div');
	ed.id = "block-"+uuid;
	ed.className = "block";
	var ecd = $(ed);
	//var node = $("<div/>",{
	var e = document.createElement('div');
	e.id = "dummy-"+uuid;
	e.className = 'dummy supported-node';
	var nodeData = getNodeByUUID(uuid);
	//e.innerHTML = nodeData.attributes._uservisibleid.newvalue
	var ec = $(e);
	var tp = nodeData.attributes._type.value;
	if(tp)
		ec.type = tp;
	else
		ec.type = 'Undefined';
	var cons = constructNodeChildren[ec.type];
	var newC;
	if (cons) {
		newC = cons(nodeData);
	}
	else {
		newC = constructNodeChildren["_default"](nodeData);
	}
	if(nodeData.children.length>0)
		ec.append(newC);
	ecd.append(ec);
	ecd.type = ec.type;
	return ecd;
}
$.fn.isInViewport = function() {
	  var elementTop = $(this).offset().top;
	  var elementBottom = elementTop + $(this).outerHeight();

	  var viewportTop = $(window).scrollTop();
	  var viewportBottom = viewportTop + $(window).height();

	  return elementBottom > viewportTop && elementTop < viewportBottom;
	};
function constructTree(uuid,useold) {
	// Obtain the node data (parse output as JSON string)
	var e = document.createElement('div');
	e.id = "block-"+uuid;
	e.className = "block";
	var ec = $(e);
	
	var nodeData = getNodeByUUID(uuid);
	
	var constructor = constructNodeProcessor[nodeData.attributes._type.value];
	var newNode;
	if (constructor) {
		newNode = constructor(nodeData, uuid);
		newNode.type = nodeData.attributes._type.value;
	}
	else {
		newNode = $();
		newNode.type = 'Undefined';
	}
	var constructor = constructNodeChildren[nodeData.attributes._type.value];
	var newC = null;
	if(useold){
		var cc= $(document.getElementById("allchildren-"+nodeData.uuid));
		if(cc.length>0)
			newC = cc[0];
	}
	newNode.uuid = newNode.id;
	if(newC==null){
		if (constructor) {
			newC = constructor(nodeData);
		}
		else {
			newC = constructNodeChildren["_default"](nodeData);
		}
	}
	newNode.find('.dummychildren').each(function(elem){
			var vele = $(this);
			vele.replaceWith(newC);
		});
	ec.append(newNode);
	return ec;
}

function clearSelection(){
	if (countEditorInstances()>0)
		for(var name in CKEDITOR.instances)
			CKEDITOR.instances[name].selection.collapse();
	if (window.getSelection) {
		window.getSelection().removeAllRanges();
	} else {
	    document.selection.empty();
	}
}
function updateElList(){
	all_active_elems = $('.supported-node');
	all_editable_elems = $('.supported-node .reditable');
}
//Reads the tree contents starting from UUID specified and updates the document
//Input parameters:
//	uuid - UUID of the root element of the updated subtree
//Return value:
//	none
function updateTree(uuid,deep,path) {
	// Remember the focused item and its nearest neighbour
	printToConsole("call tree!");
	if(countEditorInstances()>0)
		closeEditor();
	var focused_id;
	var prev_id;
	if (all_active_elems && keyboard_focus>-1) {
		focused_id = all_active_elems[keyboard_focus].id;
		if (keyboard_focus > 0)
			prev_id = all_active_elems[keyboard_focus - 1].id;
	}
	var nd = getNodeByUUID(uuid);
	nd.path = path;
	nd.deep = deep;
	// Create the updated tree contents
	var newNode = constructTree(uuid,true);
	// Insert the new tree into the document
	var currentNode = $('#block-' + uuid);
	var isNew = false;
	if (!currentNode.length) {
		// Node does not exist, append it into the contents block
		newNode.appendTo('#contents');
		if(!newNode.is(":visible"))
			{
				newNode.parents(".hiddenChilds").each(function(){
					var uuid = extractUUID(this.id);
					toggleChildren(uuid, 0, true);		
				});
			}
		isNew = true;
	}
	else {
		var hidden = [];
		var hcount = 0;
		currentNode.find('.hiddenChilds').each(function(ind,elem){
			if(elem.id!=""){
				hidden[hcount++] = elem.id;
			}
		});
		if(currentNode.hasClass(".hiddenChilds"))
			hidden[hcount++] = currentNode.id;
		// Node exists, replace it with the new data
		currentNode.replaceWith(newNode);
		for(var i = 0;i<hcount;i++){
			var uuid = extractUUID(hidden[i]);
			toggleChildren(uuid, 0, true);
		}
	}
		$('.extraAttrs').scrollToFixed({
				 marginTop: $('#toolsPanel').outerHeight(true) + 10,
                limit: function() {
                	var node = $(this).closest('.supported-node'); 
                    var limit = 0;
                    limit = node.offset().top + node.outerHeight() - $(this).outerHeight(true)-10;
                    return limit;
                },
                preFixed: function() {
                	var node = $(this).closest('.supported-node'); 
                },
                zIndex: 998
            });
	// Update the lists of elements
	updateElList();
	// Search for the element that was focused before updating
	var keyboard_focus_new = 0;
	if (focused_id) {
		// Trying to find the focused element
		keyboard_focus_new = all_active_elems.index($('#' + focused_id));
		if ((keyboard_focus_new == -1) && prev_id) {
			// Not found (maybe, removed?), searching for the neighbour
			keyboard_focus_new = all_active_elems.index($('#' + prev_id));
		}
		if (keyboard_focus_new == -1) {
			// Not found either, go to the root
			// TODO: Set focus at the first existing parent
			keyboard_focus_new = 0;
		}
	}
	if(!isNew && countEditorInstances()>0)
		return;
	clearSelection();
	setFocusByIndex(keyboard_focus_new, true);
	hideMenu();
}

//New jQuery objects method: dimensions()
//Combines all the dimensions of the node into single object
//Input parameters:
//	none
//Return value:
//	Object with element dimensions (left, right, top, bottom - position; width, height - size)
$.fn.dimensions = function () {
	var off = this.offset();
	if (!off)
		off = {left: 0, top: 0};
	off.width = this.outerWidth() || this.width();
	off.height = this.outerHeight() || this.height();
	off.right = off.left + off.width;
	off.bottom = off.top + off.height;
	return off;
};

//New jQuery objects method: scrollToView()
//Scrolls the window so that the element became visible
//Input parameters:
//	none
//Return value:
//	this (allowing for chained calls)
$.fn.scrollToView = function () {
	try{
		var elemOff = this.dimensions();
		var wndOff = $(window).dimensions();
		var scrollItem = $('html, body');
		var wndH = wndOff.height-MENU_OFFSET;
		var oldScrollPos = scrollItem.scrollTop()+MENU_OFFSET;
		var newScrollPos;
		if (elemOff.height > wndH) {
			// Element is higher than window. If it is partially hidden below the window,
			// scroll to top; if it is partially hidden above the window, scroll to bottom.
			if (elemOff.top < oldScrollPos)
				newScrollPos = elemOff.top;
			else if (elemOff.bottom > oldScrollPos + wndH)
				newScrollPos = elemOff.bottom-wndH;
		}
		else if (elemOff.top < oldScrollPos) {
			// Element is above the window viewport
			newScrollPos = elemOff.top;
		}
		else if (elemOff.bottom > oldScrollPos + wndH) {
			// Element is below the window viewport
			newScrollPos = elemOff.bottom-wndH;
		}
		if(newScrollPos)
			scrollItem.animate({
		      scrollTop: newScrollPos-MENU_OFFSET
		    }, 300);
	}
	catch(e){
		alert(e);
	}
	//this.scrollTop();
	return this;
};

//Mapping of HTML class names to Requality node types
var nodeClassToType = {
	'requirement': 'Requirement',
	'comment': 'Comment',
	'textnode': 'TextNode'
};

//Converts HTML class name of the node into Requality node type
//Input parameters:
//	elem - jQuery object with the element to check
//Return value:
//	name of the node type, or null if type is unknown
function getNodeType(elem) {
	for (var className in nodeClassToType)
		if (elem.hasClass(className))
			return nodeClassToType[className];
	return null;
}

////////////////////////////////////////////////////////////////////////////////
//Commands that can be used for hotkey assignments

/*
Calling conventions:
Each function has the following signature:

	function myCommand(uuid) {
		do_something();
	}

The input argument uuid contains the UUID of the target node. Target node is the focused
element (if the command was called from keyboard), or the active element (if the command
was called from the drop-down element's menu).
Inside the function you can also use 'this' which points to the target DOM element itself.
*/

//Command function: Switch to the previous editable item
function editPrevious(/* uuid */) {
	if (countEditorInstances()==0)
		return;
	for(var name in CKEDITOR.instances)
		if(CKEDITOR.instances[name].config.bodyClass=='miniCKE')
			return;
	var editor = CKEDITOR.currentInstance;
	if(!editor || editor == null || editor.status =="destroyed")
		return;
	var pos = all_editable_elems.index(editor.element.$);
	if (pos == 0)
		pos = all_editable_elems.length - 1;
	else
		--pos;
	setFocus($(all_editable_elems[pos]).parent());
	putEditor(all_editable_elems[pos], false);
}

//Command function: Switch to the next editable item
function editNext(/* uuid */) {
	if (countEditorInstances()==0)
		return;
	for(var name in CKEDITOR.instances)
		if(CKEDITOR.instances[name].config.bodyClass=='miniCKE')
			return;
	var editor = CKEDITOR.currentInstance;
	if(!editor || editor == null || editor.status =="destroyed")
		return;
	var pos = all_editable_elems.index(editor.element.$);
	if (pos == all_editable_elems.length - 1)
		pos = 0;
	else
		++pos;
	setFocus($(all_editable_elems[pos]).parent());
	putEditor(all_editable_elems[pos], false);
}

//Command function: Close editor discarding the changes
function closeEditor(/* uuid */) {
	// TODO: Calling requalitySave/requalityExit causes errors!
	// Temporarily wrapped into try-catch block to allow script to continue executing.
	var i=0;
	printToConsole("call close!");
	var arr=[];
	for(var name in CKEDITOR.instances)
	{
		try{
			arr[i++]=CKEDITOR.instances[name];
		}
		catch (ex){printToConsole(ex.name+" "+ex.message+" "+ex.trace);}
	}
	var ed = CKEDITOR.currentInstance;
	if(!ed && ed != null && e.status !="destroyed")
		arr[i++]=CKEDITOR.currentInstance;
	for(var j=0;j<i;j++){
		try{
			var editor = arr[j];
			editor.execCommand('requalityExit');
			//editor.destroy();
		}
		catch (ex){printToConsole(ex.name+" "+ex.message+" "+ex.trace);}
	}
}

//Command function: Close editor saving all the changes
function saveEditor(id/* uuid */) {
	// TODO: Calling requalitySave/requalityExit causes errors!
	// Temporarily wrapped into try-catch block to allow script to continue
	// executing.
	var i=0;
	var arr=[];
	for(var name in CKEDITOR.instances)
	{
		try{
			arr[i++]=CKEDITOR.instances[name];
		}
		catch (ex){printToConsole(ex.name+" "+ex.message+" "+ex.trace);}
	}
	var ed = CKEDITOR.currentInstance;
	if(!ed && ed != null && e.status !="destroyed")
		arr[i++]=CKEDITOR.currentInstance;
	for(var j=0;j<i;j++){
		try{
			var editor = arr[j];
			if(editor.checkDirty())
				editor.execCommand('requalitySave');
			else	
				editor.execCommand('requalityExit');
			//editor.destroy();
		}
		catch (ex){printToConsole(ex.name+" "+ex.message+" "+ex.trace);}
	}
}

function stacktrace() {
    var err = new Error();
    return err.stack;
}
//Command function: Move focus to the previous focusable node
function focusPrevious(/* uuid */) {
	var keyboard_focus_new = keyboard_focus;
	while (--keyboard_focus_new >= 0) {
		if ($(all_active_elems[keyboard_focus_new]).is(':visible')) {
			setFocusByIndex(keyboard_focus_new);
			return;
		}
	}
	// If failed to go to change active element, scroll to the current one
	$(this).scrollToView();
}

//Command function: Move focus to the next focusable node
function focusNext(/* uuid */) {
	var keyboard_focus_new = keyboard_focus;
	while (++keyboard_focus_new <= all_active_elems.length - 1) {
		if ($(all_active_elems[keyboard_focus_new]).is(':visible')) {
			setFocusByIndex(keyboard_focus_new);
			return;
		}
	}
	// If failed to go to change active element, scroll to the current one
	$(this).scrollToView();
}

function hasVisibleChildren(uuid){
	var nd = getNodeByUUID(uuid);
	for(var uid in nd.children){
		var ct = getType(nd.children[uid]);
		if(allowedTypes.indexOf(ct)>-1)
			return true;
	}
	return false;
}            
//Command function: Collapse node or move to the parent node
function navigateLeft(uuid) {
	if ($(this).parent().hasClass('collapsable')) {
		if ($(this).parent().children('.children-General-'+uuid+'').is(':visible')) {
			toggleChildren(uuid);
		}
		else {
			setFocus($($(this).closest('.collapsable').parent().closest('.collapsable').children('.requirement,.textnode')[0]));
			return;
		}
	}
	else {
		setFocus($($(this).closest('.collapsable').children('.requirement,.textnode')[0]));
		return;
	}
	$(this).scrollToView();
}

//Command function: Expand node or move to the next focusable node
function navigateRight(uuid) {
	if ($(this).parent().hasClass('collapsable') && $(this).parent().children('.children-General-'+uuid+'').is(':hidden')) {
		toggleChildren(uuid);
	}
	else {
		var keyboard_focus_new = keyboard_focus;
		while (++keyboard_focus_new <= all_active_elems.length - 1) {
			if ($(all_active_elems[keyboard_focus_new]).is(':visible')) {
				setFocusByIndex(keyboard_focus_new);
				return;
			}
		}
	}
	$(this).scrollToView();
}

//Command function: Expand the current node
function expandNode(uuid) {
	if ($(this).parent().hasClass('collapsable') && $(this).parent().children('.children-General-'+uuid+'').is(':hidden')) {
		toggleChildren(uuid);
	}
	$(this).scrollToView();
}

//Command function: Collapse the current node
function collapseNode(uuid) {
	if ($(this).parent().hasClass('collapsable') && $(this).parent().children('.children-General-'+uuid+'').is(':visible')) {
		toggleChildren(uuid);
	}
	$(this).scrollToView();
}

//Command function: Move focus to the element located one page above the current one
function pageUp(/* uuid */) {
	var keyboard_focus_new = keyboard_focus;
	var keyboard_focus_tmp = keyboard_focus;
	var new_pos = $(this).offset().top - $(window).height();
	while (--keyboard_focus_tmp >= 0) {
		var elem_tmp = $(all_active_elems[keyboard_focus_tmp]);
		if (elem_tmp.is(':visible')) {
			keyboard_focus_new = keyboard_focus_tmp;
			if (elem_tmp.offset().top <= new_pos)
				break;
		}
	}
	if (keyboard_focus_new != keyboard_focus) {
		setFocusByIndex(keyboard_focus_new);
		return;
	}
	$(this).scrollToView();
}

//Command function: Move focus to the element located one page below the current one
function pageDown(/* uuid */) {
	var keyboard_focus_new = keyboard_focus;
	var keyboard_focus_tmp = keyboard_focus;
	var new_pos = $(this).offset().top + $(window).height();
	while (++keyboard_focus_tmp <= all_active_elems.length - 1) {
		var elem_tmp = $(all_active_elems[keyboard_focus_tmp]);
		if (elem_tmp.is(':visible')) {
			keyboard_focus_new = keyboard_focus_tmp;
			if (elem_tmp.offset().top >= new_pos)
				break;
		}
	}
	if (keyboard_focus_new != keyboard_focus) {
		setFocusByIndex(keyboard_focus_new);
		return;
	}
	$(this).scrollToView();
}

//Command function: Move focus to the first focusable node
function focusFirst(/* uuid */) {
	var keyboard_focus_new = -1;
	while (++keyboard_focus_new <= all_active_elems.length - 1) {
		if ($(all_active_elems[keyboard_focus_new]).is(':visible')) {
			setFocusByIndex(keyboard_focus_new);
			return;
		}
	}
	$(this).scrollToView();
}

//Command function: Move focus to the last focusable node
function focusLast(/* uuid */) {
	var keyboard_focus_new = all_active_elems.length;
	while (--keyboard_focus_new >= 0) {
		if ($(all_active_elems[keyboard_focus_new]).is(':visible')) {
			setFocusByIndex(keyboard_focus_new);
			return;
		}
	}
	$(this).scrollToView();
}

//Command function: Edit requirement/test purpose description
function editDescription(/* uuid */) {
	if (!isEditable($(this)))
		return;
	if (countEditorInstances()>0) {
		for(var name in CKEDITOR.instances)
		{
			//TODO active
			var editor=CKEDITOR.instances[name];
			if(extractUUID(editor.element.$.id)==extractUUID(this.id) &&
				editor.config.bodyClass == 'normalCKE')
					return;
		}
		saveEditor();
	}
	if(keyboard_focus>-1)
		$($(all_active_elems[keyboard_focus]).find('.nodedesc')[0]).dblclick();
}

//Command function: Edit requirement name/test purpose ID (if description editor is opened
//it is closed with saving)
function editNameId(/* uuid */) {
	if (!isEditable($(this)))
		return;
	if (countEditorInstances()>0) {
		for(var name in CKEDITOR.instances)
		{
			var editor=CKEDITOR.instances[name];
			if(extractUUID(editor.element.$.id)==extractUUID(this.id) &&
				editor.config.bodyClass == 'miniCKE')
					return;
		}
		saveEditor();
	}
	if(keyboard_focus>-1)
		$($(all_active_elems[keyboard_focus]).find('.nodetitle')[0]).dblclick();
}


function countEditorInstances(){
	var x = 0; 
	for(var instance in CKEDITOR.instances){ x++; }
	return x; 
}


//Command function: Save & close editor if requirement name/test purpose ID is being edited
function saveNameId(/* uuid */) {
	for(var name in CKEDITOR.instances){
		var editor = CKEDITOR.instances[name];
		if (editor && editor.element) {
			if (editor.config.bodyClass == 'miniCKE'){
				saveEditor();
				}
		}
	}
}

//Names of the Requality attribute responsible for storing node status
var statusAttr = {
	'Requirement': 'coverageStatus',
	'TextNode': '_textNodeType'
};

//List of possible statuses for different node types
var node_statuses = {
	'Requirement': {
		'in process': {
			icon: 'req-status-incomplete.png',
			className: 'status-normal'
		},
		'complete': {
			icon: 'req-status-complete.png',
			className: 'status-complete'
		},
		'verified': {
			icon: 'req-status-verified.png',
			className: 'status-verified'
		}
	},
	'TextNode':{

		'text': {
			icon: 'tntext.png',
			className: 'type-text'
		},

		'header': {
			icon: 'tnheader.png',
			className: 'type-header'
		}
	}
};


//Command function: Switch status of the requirement or test purpose //or text node
function changeStatus(uuid,type,status,silent) {
	var img = $('#status-' + uuid);
	var current_status = img.attr('alt');
	var new_status;
	var nodeType="";
	if(type)
		nodeType = type;
	else
		nodeType = getNodeType($(this));
	if(status)
		new_status=status;
	else
		if(nodeType == "TextNode"){
			if (current_status == 'text')
				new_status = 'header';
			else
				new_status = 'text';
			if (isReadOnly($(this)))
				return;
		}else{
			if (!isReadOnly($(this))) {
				// In normal mode 'verified' is unavailable
				if (current_status == 'in process')
					new_status = 'complete';
				else
					new_status = 'in process';
			}
			else {
				// In read-only (review) mode all statuses are allowed to be set
				if (current_status == 'in process')
					new_status = 'complete';
				else if (current_status == 'complete')
					new_status = 'verified';
				else
					new_status = 'in process';
			}
		}
	img.attr('alt', new_status).attr('title', new_status);
	img.attr('src', 'images/' + getNodeStatus(nodeType, new_status).icon);
	$(this).find('.nodetitle').removeClass(getNodeStatus(nodeType,current_status).className).addClass(getNodeStatus(nodeType,new_status).className);
	if(!silent)
		changeNodeAttr(uuid, statusAttr[nodeType], new_status);
}

//Command function: Delete the node after confirming the decision
function deleteNodeConfirm(uuid) {
log.debug( "deleteNodeConfirm( " + uuid + ")" );	
	if (!canDeleteNode(extractUUID(this.id)) || !isEditable($(this)))
		return;
	removeNode(uuid);
}

//Command function: Add new child requirement (name is requested)
function addChildRequirementConfirm(uuid) {
	if ((readOnlyMode & EDIT_MODE_REQ_RO) != 0)
		return;
	if (!canContainType(uuid,"Requirement"))
		return;
	var node = createNode(uuid,'Requirement',getNextAvalibleId(uuid),"Add Child Requirement[template]");
	//var new_name = prompt('Requirement Id:                                  ');
	//var new_name = openIdChange(uuid,"Add Child Requirement","Enter Id:",getNextAvalibleId(uuid));
	//if ((new_name != null) && (new_name != '')) {
		//var new_req_uuid = addNode(uuid, null, 'Requirement');
		//if (new_req_uuid != null){
			  //changeNodeAttr(new_req_uuid, '_name', new_name);
		if(node!=null && node!='')
			  nodeToFocus = node;
		//}
	//}
}

//Command function: Add new sibling requirement (name is requested)
function addSiblingRequirementConfirm(uuid) {
	if ((readOnlyMode & EDIT_MODE_REQ_RO) != 0)
		return;
	//var new_name = prompt('Requirement Id:                                  ');
	var parentUUID = getParentUUID(uuid);
	var node = createNode(parentUUID,'Requirement',getNextAvalibleId(parentUUID),"Add Sibling Requirement[template]");
	//var new_name = openIdChange(parentUUID,"Add Sibling Requirement","Enter Id:",getNextAvalibleId(parentUUID));
	//if ((new_name != null) && (new_name != '')) {
		//var new_req_uuid = addNode(parentUUID, null, 'Requirement');
	//	if (new_req_uuid != null){
		//	  changeNodeAttr(new_req_uuid, '_name', new_name);
		//	  nodeToFocus = new_req_uuid;
		//}
//	}
	if(node!=null && node!='')
		  nodeToFocus = node;
}

function addChildTextNodeConfirm(uuid) {
	if ((readOnlyMode & EDIT_MODE_REQ_RO) != 0)
		return;
	if (!canContainType(uuid,"TextNode"))
		return;
	var node = createNode(uuid,'TextNode',getNextAvalibleId(uuid),"Add Child Text Node[template]");
	if(node!=null && node!='')
		  nodeToFocus = node;
}

//Command function: Add new sibling requirement (name is requested)
function addSiblingTextNodeConfirm(uuid) {
	if ((readOnlyMode & EDIT_MODE_REQ_RO) != 0)
		return;
	//var new_name = prompt('Requirement Id:                                  ');
	var parentUUID = getParentUUID(uuid);
	var node = createNode(parentUUID,'TextNode',getNextAvalibleId(parentUUID),"Add Sibling Text Node[template]");
	//var new_name = openIdChange(parentUUID,"Add Sibling Requirement","Enter Id:",getNextAvalibleId(parentUUID));
	//if ((new_name != null) && (new_name != '')) {
		//var new_req_uuid = addNode(parentUUID, null, 'Requirement');
	//	if (new_req_uuid != null){
		//	  changeNodeAttr(new_req_uuid, '_name', new_name);
		//	  nodeToFocus = new_req_uuid;
		//}
//	}
	if(node!=null && node!='')
		  nodeToFocus = node;
}


//Command function: Add new comment as requirement's or test purpose's child or another comment's sibling
function addComment(uuid) {
	// Get the wrapping block of the target requirement/test purpose
	// or of the target comment's parent requirement (if it is a comment)
	var req_elem = $(this).closest('.nodewrapper');
	// Create the child test purpose if there are no children requirements
	//var id = addNode(extractUUID(req_elem[0].id), null, 'Comment', uuid);
	//if(id)
		   //nodeToFocus = id;
	var node = createNode(extractUUID(req_elem[0].id),'Comment',null,"Add Comment[template]",uuid);
	
	if(node!=null && node!='')
		  nodeToFocus = node;
}

var internalClipboard;
var internalClipboardCopyMode;

function callAddTest(uuid){
	addTest(uuid);
}

function openTemplates(uuid){
	callOpenTemplates(uuid);
}

function editNode(uuid){
	if(canEditNode(uuid))
		callEditNode(uuid);
}
//Command function: Copy node to the internal clipboard (store the uuid)
function copyNodeToClipboard(uuid) {
	if (!isEditable($(this)))
		return;
	copyNode(uuid, false);
}

//Command function: Cut node to the internal clipboard (store the uuid)
function cutNodeToClipboard(uuid) {
	if (!isEditable($(this)))
		return;
	copyNode(uuid,true);
}

//Command function: Paste the copied node as the current node's sibling
function pasteNodeAsSibling(uuid) {
	if (!isEditable($(this)))
     return;
	var target_uuid = extractUUID($('#block-' + uuid).parent().closest('.nodewrapper')[0].id);
	return pasteNode(target_uuid, false, uuid);
}

//Command function: Paste the copied node with all its children as the current node's sibling
function pasteSubtreeAsSibling(uuid) {
	if (!isEditable($(this)))
     return;
	var target_uuid = extractUUID($('#block-' + uuid).parent().closest('.nodewrapper')[0].id);
 return pasteNode(target_uuid,true, uuid);
}

//Command function: Paste the copied node as the current node's child
function pasteNodeAsChild(uuid) {
	if (!isEditable($(this)))
     return;
 return pasteNode(uuid,false);
}

//Command function: Paste the copied node with all its children as the current node's child
function pasteSubtreeAsChild(uuid) {
	return pasteNode(uuid,true);
}

////////////////////////////////////////////////////////////////////////////////
//Startup actions

//Additional styles that should be applied into CKEditor when editing elements of specific class
var CKEditorStyles = {
	'reqname': 'body { margin: 1px; font-size: 125%; font-weight: bold; }'
};

//Processors for starting to drag different types of elements: determines the starting position
//for drag&drop highlighting and sets the appropriate classes to allow/disallow drop targets
//Input parameters:
//	dragging_uuid - UUID of the element being dragged
//Return value:
//	Initial value for the node indices to follow the mouse cursor
function dragRequirement(dragging_uuid, req_elems) {
	var underlying_req_idx = req_elems.index($('#node-' + dragging_uuid)) - 1;
	if (underlying_req_idx < 0) {
		underlying_req_idx = null;
	}
	// Disallow dragging onto itself and children
	$('#block-' + dragging_uuid + ' .requirement').addClass('undroppable');
	// Make the whole node (including children) look disabled
	$('#block-' + dragging_uuid).addClass('disabled');
	for(var i = 0; i < req_elems.length; i++){
		var kuuid = extractUUID(req_elems[i].id);
		if(!checkChild(dragging_uuid, "", kuuid)){
			if(!$('#node-' + kuuid).hasClass('undroppable'))
				  $('#node-' + kuuid).addClass('undroppable');
			if(!$('#node-' + kuuid).hasClass('disabled'))
				  $('#node-' + kuuid).addClass('disabled');
		}
	}
	return underlying_req_idx;
}
var draggingInitHandler = {
	'reqdesc': dragRequirement,
	'reqname': dragRequirement,
	'cmtdesc': function (dragging_uuid, req_elems) {
		var underlying_req_idx = req_elems.index($('#node-' + dragging_uuid)) - 1;
     if (underlying_req_idx < 0) {
         underlying_req_idx = null;
     }
     // Disallow dragging onto itself
     $('#node-' + dragging_uuid).addClass('undroppable');
     // Make the whole node look disabled
     $('#node-' + dragging_uuid).addClass('disabled');
     return underlying_req_idx;
 },
	'tndesc': function (dragging_uuid, req_elems) {
		var underlying_req_idx = req_elems.index($('#node-' + dragging_uuid)) - 1;
     if (underlying_req_idx < 0) {
         underlying_req_idx = null;
     }
     // Disallow dragging onto itself
     $('#node-' + dragging_uuid).addClass('undroppable');
     // Make the whole node look disabled
     $('#node-' + dragging_uuid).addClass('disabled');
     var subtree = [];
     var children = getChildrenUUIDs(dragging_uuid);
		while(children.length>0){
			var uid = children.pop();
			subtree.push(uid);
			children = children.concat(getChildrenUUIDs(uid));
		}
     for(var i = 0; i < req_elems.length; i++){
			var kuuid = extractUUID(req_elems[i].id);
			if(subtree.indexOf(kuuid)>-1){
				if(!$('#node-' + kuuid).hasClass('undroppable'))
					  $('#node-' + kuuid).addClass('undroppable');
				if(!$('#node-' + kuuid).hasClass('disabled'))
					  $('#node-' + kuuid).addClass('disabled');
			}
		}
     return underlying_req_idx;
 }
};


$(function () {
	try{
	// Request for the current read-only mode
	readOnlyMode = getReadOnlyMode();

	// On startup, request the nodes and create the HTML contents
	loadNodeSubtreeByUUID(getStartNode());
	updateTree(getStartNode(),0,"");
	replaceDummies($(document));
	updateElList();
	setFocusByUUID(getSelectedNode(), true);
	document.addEventListener('scroll', function (event) {
		$(".dummy").each(function(elem){
			var c = $(this);
			if(c.isInViewport()){
				replaceDummies(c.parent());
			}
		});
	}, true /*Capture event*/);
	// When simplified editor is opened, update its internal styles
	// addCss() must be called before editor is loaded, so put it into 'instanceCreated'
	// Assign drag&drop action to the element titles (those allowed to be edited)
	// Mousedown is initial event for dragging, but real dragging actions will be performed
	// only on first moving, so that we could rename element by simply clicking it
	$('.dragable').live('mousedown', function (e) {
		if(!isEditable($(this).closest('.supported-node')) || countEditorInstances()>0)
			return;
//		e.preventDefault();
//		e.stopPropagation();
		var dragging_init = this;
		var dragging;
		var dragging_uuid = extractUUID(dragging_init.id);
		//alert(dragging_uuid);
		var dims = $(dragging_init).dimensions();
		var mouseDX = e.pageX - dims.left;      // Remember position of the mouse relative to the dragged element
		var mouseDY = e.pageY - dims.top;
		var scroll_speed = 0;                   // Speed of automatic scrolling
		var scroll_timer;                       // Timer for performing automatic scrolling
		var doc_height = $(document).height();  // Protect from heigth increasing when moving dragged element below bottom
		var wnd_height = $(window).height();
		var elem = this;
		
		// Data needed for requirement highlighting during drag&drop
		// They will be initialized later (to avoid delays in processing clicks without drag&drop)
		var req_elems;                          // List of all requirement nodes available for highlighting
		var underlying_req_idx1;                // Indices of the requirement nodes between which the mouse cursor is
		var underlying_req_idx2;                // node1 is the higher node, node2 is the lower one (they can be equal)

		// Updates highlighting of the target requirement (under mouse cursor)
		// Input parameters:
		//	(mx, my) - mouse cursor position
		// Return value:
		//	none
		var reqHighlight = function (mx, my) {
			if ((underlying_req_idx1 == null) || (underlying_req_idx2 == null))
				return;

			var elem1_current = $(req_elems[underlying_req_idx1]);
			var dims1_current = elem1_current.dimensions();
			var elem2_current = $(req_elems[underlying_req_idx2]);
			var dims2_current = elem2_current.dimensions();

			if (my < dims1_current.top) {
				// Above the node1
				elem1_current.removeClass('droppable');     // Unhighlight the node1 if it was highlighted
				underlying_req_idx2 = underlying_req_idx1;  // node1 becomes the new node2
				// Search for the new nodes where the mouse cursor is located now
				// (either on a node, or between two nodes)
				var tmp_idx1 = underlying_req_idx1;
				while (tmp_idx1 > 0) {
					--tmp_idx1;
					var elem_prev = $(req_elems[tmp_idx1]);
					if (elem_prev.is(':hidden')) {
						// Skip collapsed requirements
						continue;
					}
					underlying_req_idx1 = tmp_idx1;
					var dims_prev = elem_prev.dimensions();
					if (my > dims_prev.bottom) {
						// Cursor is between two nodes
						return;
					}
					else if ((my >= dims_prev.top) && (my <= dims_prev.bottom)) {
						// Cursor is vertically aligned with the node
						underlying_req_idx2 = underlying_req_idx1;
						if ((mx >= dims_prev.left) && (mx <= dims_prev.right)) {
							// Cursor is inside the node, set highlighting if necessary
							if (!elem_prev.hasClass('undroppable') && !elem_prev.hasClass('droppable'))
								elem_prev.addClass('droppable');
						}
						return;
					}
					else /* if (my < dims_prev.top) */ {
						// Cursor is even higher, shift the indices and continue searching upwards
						underlying_req_idx2 = underlying_req_idx1;
					}
				}
				return;
			}
			else if ((my >= dims1_current.top) && (my <= dims1_current.bottom)) {
				// Aligned with the node1
				underlying_req_idx2 = underlying_req_idx1;
				if ((mx >= dims1_current.left) && (mx <= dims1_current.right)) {
					// Cursor is inside the node1, set highlighting if necessary
					if (!elem1_current.hasClass('undroppable') && !elem1_current.hasClass('droppable'))
						elem1_current.addClass('droppable');
				}
				else {
					// node1 is not under the cursor - unhighlight it
					elem1_current.removeClass('droppable');
				}
				return;
			}
			else if ((my > dims1_current.bottom) && (my < dims2_current.top)) {
				// Between node1 and node2 (can happen only when the nodes are not the same)
				elem1_current.removeClass('droppable');
				elem2_current.removeClass('droppable');
			}
			else if ((my >= dims2_current.top) && (my <= dims2_current.bottom)) {
				// Aligned with the node2
				underlying_req_idx1 = underlying_req_idx2;
				if ((mx >= dims2_current.left) && (mx <= dims2_current.right)) {
					// Cursor is inside the node2, set highlighting if necessary
					if (!elem2_current.hasClass('undroppable') && !elem2_current.hasClass('droppable'))
						elem2_current.addClass('droppable');
				}
				else {
					// node2 is not under the cursor - unhighlight it
					elem2_current.removeClass('droppable');
				}
				return;
			}
			else /* if (my > dims2_current.bottom) */ {
				// Below the node2
				elem2_current.removeClass('droppable');     // Unhighlight the node1 if it was highlighted
				underlying_req_idx1 = underlying_req_idx2;  // node2 becomes the new node1
				// Search for the new nodes where the mouse cursor is located now
				// (either on a node, or between two nodes)
				var tmp_idx2 = underlying_req_idx2;
				while (tmp_idx2 < req_elems.length - 1) {
					++tmp_idx2;
					var elem_next = $(req_elems[tmp_idx2]);
					if (elem_next.is(':hidden')) {
						// Skip collapsed requirements
						continue;
					}
					underlying_req_idx2 = tmp_idx2;
					var dims_next = elem_next.dimensions();
					if (my < dims_next.top) {
						// Cursor is between two nodes
						return;
					}
					else if ((my >= dims_next.top) && (my <= dims_next.bottom)) {
						// Cursor is vertically aligned with the node
						underlying_req_idx1 = underlying_req_idx2;
						if ((mx >= dims_next.left) && (mx <= dims_next.right)) {
							// Cursor is inside the node, set highlighting if necessary
							if (!elem_next.hasClass('undroppable') && !elem_next.hasClass('droppable'))
								elem_next.addClass('droppable');
						}
						return;
					}
					else /* if (my > dims_next.bottom) */ {
						// Cursor is even lower, shift the indices and continue searching downwards
						underlying_req_idx1 = underlying_req_idx2;
					}
				}
				return;
			}
		};

		// Automatic scrolling handler
		var scrollWatcher = function () {
			if ((scroll_speed > 0) && ($(document).scrollTop() + wnd_height < doc_height) ||
				(scroll_speed < 0) && ($(document).scrollTop() > 0)) {
				// Perform scrolling only if not at the very top/bottom of the document
				window.scrollBy(0, Math.round(scroll_speed / 90));
				// Calculate the updated position of the mouse (can do it since dragged element is 'display: fixed')
				var dragging_off = dragging.offset();
				// Update the target node highliting
				reqHighlight(dragging_off.left + mouseDX, dragging_off.top + mouseDY);
			}
		};

		var dnd_overlay;
		var dnd_keys = { ctrlKey: false, shiftKey: false };
		//actions for links actions. Calls 'onaction' event
		//of element. Now used for links(linkto:).
	    $(document).bind('mousemove.drag', function (e) {	    	
			e.preventDefault();
			if (!dragging) {
				// First mouse move after pressing the button - initialize dragging
				// Create a duplicate of the requirement name (it will be dragged
				// while the original one remains on its place)
				dragging = $(dragging_init).clone().removeAttr('id').css({
					opacity: 0.7,
					position: 'fixed',
					left: dims.left + 'px',
					top: dims.top + 'px',
					zIndex: 1010,
					cursor: 'move',
					backgroundColor: '#f7f7ff',
					borderColor: '#c0c0c0'
				}).appendTo(document.body);
				// Initialize highlighting data and assign special styles to some nodes
				// to indicate impossibility of dropping the element there:
				// 'undroppable' is set to requirement nodes to disallow highlighting;
				// 'disabled' is set to visualize unavailability of nodes by paleness
				//req_elems = $('.requirement');
				req_elems = $('.supported-node');
				for (var className in draggingInitHandler) {
					if ($(dragging_init).hasClass(className)) {
						underlying_req_idx2 = underlying_req_idx1 = draggingInitHandler[className].call(null, dragging_uuid, req_elems);
					}
				}

				// Create the transparent overlay over the document so that text could not be selected
				// (in addition prevents triggering hover events of the underlying elements)
				if ($('#dnd-overlay').length == 0) {
					// If overlay is missing create it
					$('<div id="dnd-overlay"></div>').css({
						display: 'none',
						position: 'absolute',
						top: '0px',
						left: '0px',
						cursor: 'move',
						zIndex: 1000
					}).appendTo(document.body);
				}
				// Update the size (in case document sizes changed) and display
				$('#dnd-overlay').css({
					width: $(document).width() + 'px',
					height: $(document).height() + 'px'
				}).show();

				// Initialize autoscrolling watcher
				scroll_timer = setInterval(scrollWatcher, 20);

				// Create the "plus-sheet" overlay to indicate copying
				dnd_overlay = $('<img src="images/dnd-copy.png" alt="" id="dnd-cursor-overlay" />').css({
					position: 'absolute',
					display: 'none',
					opacity: 0.6,
					zIndex: 1020
				}).appendTo(document.body);

				// Listen to keypresses to handle Ctrl and Shift
				$(document).bind('keydown.drag keyup.drag', function (e) {
					var dnd_keys_changed = false;
					if (e.type == 'keydown') {
						if (e.keyCode == 17) {
							// Ctrl is pressed
							if (!dnd_keys.ctrlKey) {
								dnd_keys.ctrlKey = true;
								dnd_keys_changed = true;
							}
						}
						else if (e.keyCode == 16) {
							// Shift is pressed
							if (!dnd_keys.shiftKey) {
								dnd_keys.shiftKey = true;
								dnd_keys_changed = true;
							}
						}
					}
					else if (e.type == 'keyup') {
						if (e.keyCode == 17) {
							// Ctrl is released
							if (dnd_keys.ctrlKey) {
								dnd_keys.ctrlKey = false;
								dnd_keys_changed = true;
							}
						}
						else if (e.keyCode == 16) {
							// Shift is released
							if (dnd_keys.shiftKey) {
								dnd_keys.shiftKey = false;
								dnd_keys_changed = true;
							}
						}
					}
					if (dnd_keys_changed) {
						// Drag&Drop type changed, updating the overlay
						if (dnd_keys.ctrlKey) {
							// Ctrl or Ctrl+Shift is pressed, update the overlay and show it
							if (dnd_keys.shiftKey)
								dnd_overlay.attr('src', 'images/dnd-copy-all.png');
							else
								dnd_overlay.attr('src', 'images/dnd-copy.png');
							var dragging_dims = dragging.dimensions();
							dnd_overlay.show().offset({
								top: dragging_dims.bottom - 10,
								left: dragging_dims.right - 10
							});
						}
						else {
							// Ctrl is not pressed, hide the overlay
							dnd_overlay.hide();
						}
					}
				});
			}

			// Update the position of the dragged element and drag&drop overlay (if it's visible)
			dragging.offset({left: e.pageX - mouseDX, top: e.pageY - mouseDY});
			if (dnd_overlay.is(':visible')) {
				var dragging_dims = dragging.dimensions();
				dnd_overlay.offset({
					top: dragging_dims.bottom - 10,
					left: dragging_dims.right - 10
				});
			}
			// Highlight the requirement the mouse is passing by
			reqHighlight(e.pageX, e.pageY);

			// Calculate auto-scrolling speed (non-zero when mouse is at the top/bottom of the window)
			var scrollTop = $(document).scrollTop();
			if (e.pageY - scrollTop < 30) {
				// Top of the window, scroll up (negative speed)
				// Max speed is 1800 px/sec
				var diff = e.pageY - scrollTop;
				if (diff < 0)
					diff = 0;
				scroll_speed = -60 * (30 - diff);
			}
			else if (scrollTop + $(window).height() - e.pageY < 30) {
				// Bottom of the window, scroll down (positive speed)
				var diff = scrollTop + $(window).height() - e.pageY;
				if (diff < 0)
					diff = 0;
				scroll_speed = 60 * (30 - diff);
			}
			else {
				scroll_speed = 0;
			}
		}).bind('mouseup.drag', function (e) {
			// The mouse button is released: either normal click, or end of drag&drop
			e.preventDefault();
			// In any case unbind the additional event handlers
			$(document).unbind('mouseup.drag').unbind('mousemove.drag').unbind('keydown.drag').unbind('keyup.drag');
			if (dragging) {
				// Drag&drop was used - restore normal functioning by removing the dragged element,
				// hiding the overlays, unhighlighting the requirement and turning autoscroll off
				scroll_speed = 0;
				clearInterval(scroll_timer);
				dragging.remove();
				dragging = null;
				dnd_overlay.remove();
				dnd_overlay = null;
				var target = $('.droppable').removeClass('droppable');
				$('.undroppable').removeClass('undroppable');
				$('.disabled').removeClass('disabled');
				$('#dnd-overlay').hide();
				if (target.length > 0) {
					// If we released the element over a node, complete the drag&drop action
					var target_uuid = extractUUID(target[0].id);
					setFocus(target);
					if (e.ctrlKey) {
						// Ctrl was pressed, so making a copy instead of moving
						if (e.shiftKey) {
							// Ctrl+Shift was pressed, make a copy of the subtree
							copyNode(dragging_uuid, target_uuid, true);
						}
						else {
							// Only Ctrl was pressed, make a copy of the element itself
							copyNode(dragging_uuid, target_uuid, false);
						}
					}
					else {
						// No keyboard modifiers were pressed, move the element
						changeNodeParent(dragging_uuid, target_uuid,e.shiftKey);
					}
				}
			}
		});
	});

	// Make editable elements replaced with editor by clicking on them
	$('.reditable').live('dblclick', function (e) {
		e.stopPropagation();
		e.stopImmediatePropagation();
		e.preventDefault();
		var elem = document.getElementById(this.id);
		var relem = document.getElementById(this.id+"-_raw");
		if(relem != null&&(relem.innerHTML!=null)){
			elem.innerHTML=relem.innerHTML;
		}
		if(editorJavaDialog)
			return;
		var el = $(elem).closest('.supported-node');
		if (!(el.hasClass('focused')))
			setFocus(elem);
		printToConsole("reditable");
		//if(countEditorInstances()<1)
			putEditor(elem, false);
	});
	// Make renamable elements updated by clicking on them
	$('.createText').live('dblclick', function (e) {
		e.stopPropagation();
		e.stopImmediatePropagation();
		e.preventDefault();
		var elem = this;
		printToConsole(this+" "+this.id);
		if(editorJavaDialog)
			return;
		printToConsole("ctext");
		putEditor(elem, false);
		$(elem).css("height","1.2em");
		$(elem).css("background-color","#ffefff");
		$(elem).on("mouseleave",function(e){
			$(elem).css("height","0.14em");
			$(elem).css("background-color","#f0f0f0");
			
		});
		//if(countEditorInstances()<1){
		//}
	});

	$('.renamable').live('dblclick', function (e) {
		var elem = document.getElementById(this.id); 
		e.preventDefault();
		e.stopImmediatePropagation();
		e.stopPropagation();
		if(editorJavaDialog)
			return;
		var el = $(elem).closest('.supported-node');

		var relem = document.getElementById(this.id+"-_raw");
		if(relem != null&&(relem.innerHTML!=null)){
			elem.innerHTML=relem.innerHTML;
		}
		if (!(el.hasClass('focused')))
			setFocus(elem);
		//if(countEditorInstances()<1)
		putEditorWithHtmlClean(elem, true, true);
	});
	$('.supported-node').live('click', function (e) {
		if(editorJavaDialog)
			return;
		if ($(this).hasClass('focused'))
			return;
//		e.stopPropagation();
//		e.stopImmediatePropagation();
//		e.preventDefault();
		setFocus($(this));
	});
	// Expand menu for requirements and test purposes on hovering
	$('.nodectrls').live('mouseenter', function () {
		var menu_caller = $(this);
		var mn = menu_caller.children(".menu");
		if(mn.length>0){
			var bl = menu_caller.closest(".supported-node");
			if(bl.length>0){
				var uuid = extractUUID(bl.attr("id"));
				mn.html(constructMenu(getType(uuid), uuid));
			}
		}
		var menu_caller_dims = menu_caller.dimensions();
		var container;
		// If we expand the existing element it will stretch the table cell with
		// the test purpose ID or requirement name. To avoid this we create a copy of the
		// drop-down menu, position it as "absolute" above the old one and expand.
		var new_menu = menu_caller.clone().hide();
		new_menu.find('.menu-item,.menu-item-disabled').each(function(e){
			var name = $(this).find(".menu-name");
			if(name && name.text().indexOf("[template")>0){
				var text = name.text();
				var ind = text.indexOf("[template");
				var fullitem = text.substr(ind, text.indexOf("]", ind)-ind+1);
				var type = text.substr(ind+10,text.indexOf("]", ind)-ind-10);
				var uuid = extractUUID(new_menu.children(".menu")[0].id);
				//alert(uuid);
				var label = getActiveTemplateLabel(uuid,type);
				if(!label)
					label = "";
				else 
					label = " - "+label;
				name.text(name.text().replace(fullitem, label));
			}
		});
		// Change class so that the new menu did not react to 'mouseenter' second time
		new_menu.removeClass('nodectrls').addClass('nodectrls-virtual');
		if (menu_caller.hasClass('reqctrls')) {
			// The new menu is hovered, so the border around the current item disappears.
			// Set new class to keep the border.
			// Remove node-specific styles
			new_menu.removeClass('reqctrls');
		}
		else if (menu_caller.hasClass('cmtctrls')) {
			new_menu.removeClass('cmtctrls');
		}
		container = menu_caller.closest('.supported-node');
		container.addClass('supported-node-hovered');
		// Calculate how much the menu should be stretched.
		// jQuery Actual Plugin is used for getting size of a hidden element.
		var delta_width = menu_caller.find('.menu').actual('outerWidth') - menu_caller_dims.width + 15;
		var delta_height = menu_caller.find('.menu').actual('outerHeight');
		// Set mousemove listener to manually watch for mouse cursor going out of the menu
		// (mouseleave for unknown reasons is not always triggered, and menu remains on screen)
		var inside_menu = true;
		$(document).bind('mousemove.menu', function (e) {
			var menu_sz = new_menu.dimensions();
			if ((e.pageX < menu_sz.left) || (e.pageX > menu_sz.right) || (e.pageY < menu_sz.top) || (e.pageY > menu_sz.bottom)) {
				new_menu.mouseleave();
			}
		});
		// Chaining:
		// 1) setting initial position and size set to the original menu's;
		// 2) inserting the element into document;
		// 3) displaying the internal menu contents;
		// 4) animate expanding the menu;
		// 5) assigning menu collapse to moving mouse out of the menu.
		new_menu.css({
			position: 'absolute',
			top: menu_caller_dims.top + 'px',
			left: menu_caller_dims.left + 'px',
			width: menu_caller.width() + 'px',
			height: menu_caller.height() + 'px',
			zIndex: 1000
		}).appendTo(container).show().find('.menu').show().end()./*stop(true, false).*/animate({
			width: '+=' + delta_width,
			left: '-=' + delta_width,
			height: '+=' + delta_height
		}, animationPeriod).mouseleave(function () {
			// Protect from double-entering
			if (inside_menu) {
				inside_menu = false;
				// Unbind mousemove listener
				$(document).unbind('mousemove.menu');
				// When mouse goes away restore normal classes for "item-under-cursor" highlighting
				container.removeClass('supported-node-hovered');
				// ...and animate collapsing the menu
				$(this)./*stop(true, false).*/animate({
					width: '-=' + delta_width,
					left: '+=' + delta_width,
					height: '-=' + delta_height
				}, animationPeriod, function () {
					// Collapsing is finished - remove the absolute-position menu-duplicate
					$(this).remove();
				});
			}
		});
	});
	// Hotkey handlers
	$(document).keydown(function (e) {
		if(keyboard_focus==-1)
			return;
		var elem = all_active_elems[keyboard_focus];
		hotkeyManager.execHotkeyAction(e, getHotKeyMode(), elem, extractUUID(elem.id));
	});
		
	}catch(t){
		printToConsole(t.name+" "+t.message+" "+t.stack);
	}
	
});
//]]>
